//
// org.osid.Aggregateable
//
//     The OSID Java specification for org.osid.Aggregateable.
//
// Copyright (C) 2002-2004, 2006-2008 Massachusetts Institute of Technology. 
// 
// Copyright (C) 2009-2012 Ingenescus. All Rights Reserved. 
//
//     This Work is being provided by the copyright holder(s) subject to the 
//     following license. By obtaining, using and/or copying this Work, you 
//     agree that you have read, understand, and will comply with the 
//     following terms and conditions. 
//     
//     Permission to use, copy and distribute unmodified versions of this 
//     Work, for any purpose, without fee or royalty is hereby granted, 
//     provided that you include the above copyright notices and the terms of 
//     this license on ALL copies of the Work or portions thereof. 
//     
//     You may modify or create Derivatives of this Work only for your 
//     internal purposes. You shall not distribute or transfer any such 
//     Derivative of this Work to any location or to any third party. For the 
//     purposes of this license, "Derivative" shall mean any derivative of the 
//     Work as defined in the United States Copyright Act of 1976, such as a 
//     translation or modification. 
//     
//     This Work and the information contained herein is provided on an "AS 
//     IS" basis WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING 
//     BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A 
//     PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS 
//     OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
//     LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
//     FROM, OUT OF OR IN CONNECTION WITH THE WORK OR THE USE OR OTHER 
//     DEALINGS IN THE WORK. 
//     
//     The export of software employing encryption technology may require a 
//     specific license from the United States Government. It is the 
//     responsibility of any person or organization contemplating export to 
//     obtain such a license before exporting this Work. 
//

package org.osid;


/**
 *  <p><code> Aggregateable </code> is used for an <code> OsidObject </code> 
 *  to indicate that some or all of the definition is based on an included set 
 *  of other <code> OsidObjects </code> which are directly accessible and do 
 *  not exist outside the context of the parent object. <code> Aggregateables 
 *  </code> allow for an <code> OsidObject </code> to stand alone without 
 *  knowledge of the originating service. </p> 
 *  
 *  <p> An <code> Asset </code> is an example of an aggregate by including the 
 *  <code> AssetContents. </code> An Asset also contains a provider however in 
 *  this case the provider is categorized as a simple data attribute of the 
 *  <code> Asset </code> that can be changed by updating the <code> Asset 
 *  </code> using an <code> AssetForm. </code> The <code> AssetContent </code> 
 *  differs in there exists a explicit mapping to the <code> Asset </code> 
 *  managed through an <code> OsidSession </code> but accessible directly 
 *  within the <code> Asset </code> to enable its consumption outside the 
 *  Repository OSID. </p> 
 *  
 *  <p> This marker has little practicality other than to identify a service 
 *  pattern that is neither a data attribute nor a separately accessible 
 *  relationship or mapping. </p>
 */

public interface Aggregateable {
}
