//
// org.osid.OsidGovernator
//
//     The OSID Java specification for org.osid.OsidGovernator.
//
// Copyright (C) 2002-2004, 2006-2008 Massachusetts Institute of Technology. 
// 
// Copyright (C) 2009-2012 Ingenescus. All Rights Reserved. 
//
//     This Work is being provided by the copyright holder(s) subject to the 
//     following license. By obtaining, using and/or copying this Work, you 
//     agree that you have read, understand, and will comply with the 
//     following terms and conditions. 
//     
//     Permission to use, copy and distribute unmodified versions of this 
//     Work, for any purpose, without fee or royalty is hereby granted, 
//     provided that you include the above copyright notices and the terms of 
//     this license on ALL copies of the Work or portions thereof. 
//     
//     You may modify or create Derivatives of this Work only for your 
//     internal purposes. You shall not distribute or transfer any such 
//     Derivative of this Work to any location or to any third party. For the 
//     purposes of this license, "Derivative" shall mean any derivative of the 
//     Work as defined in the United States Copyright Act of 1976, such as a 
//     translation or modification. 
//     
//     This Work and the information contained herein is provided on an "AS 
//     IS" basis WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING 
//     BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A 
//     PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS 
//     OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
//     LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
//     FROM, OUT OF OR IN CONNECTION WITH THE WORK OR THE USE OR OTHER 
//     DEALINGS IN THE WORK. 
//     
//     The export of software employing encryption technology may require a 
//     specific license from the United States Government. It is the 
//     responsibility of any person or organization contemplating export to 
//     obtain such a license before exporting this Work. 
//

package org.osid;


/**
 *  <p>An <code> OsidGovernator </code> is a control point to govern the 
 *  behavior of a service. <code> OsidGovernators </code> generally indicate 
 *  the presence of <code> OsidEnablers </code> and other rule governing 
 *  interfaces to provide a means of managing service operations and 
 *  constraints from a "behind the scenes" perspective. The <code> 
 *  OsidGovernator </code> is a focal point for these various rules. </p> 
 *  
 *  <p> <code> OsidGovernators </code> are <code> Sourceable. </code> An 
 *  <code> OsidGovernator </code> implies a governance that often corresponds 
 *  to a provider of a process as opposed to a catalog provider of <code> 
 *  OsidObjects. </code> </p> 
 *  
 *  <p> <code> OsidGovernators </code> are <code> Operable. </code> They 
 *  indicate an active and operational status and related rules may be 
 *  administratively overridden using this control point. Administratively 
 *  setting the enabled or disabled flags in the operator overrides any 
 *  enabling rule mapped to this <code> OsidGovernator. </code> </p>
 */

public interface OsidGovernator
    extends org.osid.OsidObject,
            org.osid.Operable,
            org.osid.Sourceable {
}
