/**
 * <p>The Open Service Interface Definitions for the org.osid.bidding
 * service.</p>
 * 
 * <p>The Bidding OSID provides a means for running and bidding in auctions. 
 * </p> 
 * <h4> Auction </h4> 
 * 
 * <p> An <code> Auction </code> represents a single item or a lot of the same 
 * item to be sold. Auctions are sponsored by a seller within a period of time 
 * and define pricing information. </p> 
 * <h4> Bids </h4> 
 * 
 * <p> A <code> Bid </code> is an <code> OsidRelationship </code> between an 
 * <code> Auction </code> and a bidder. </p> 
 * <h4> Bidders </h4> 
 * 
 * <p> <code> Bids </code> are created by an <code> Agent. </code> The 
 * relationship between the <code> Resource </code> and the <code> Agent 
 * </code> is handled by the Bidding OSID Provider. </p> 
 * <h4> Auction Cataloging </h4> 
 * 
 * <p> <code> Auctions </code> and <code> Bids </code> are organized into 
 * <code> AuctionHouse </code> <code> OsidCatalogs </code> and can be 
 * federated using the hierarchy pattern. </p> 
 * <h4> Sub Packages </h4> 
 * 
 * <p> The Bidding OSID includes a Bidding Rules OSID for managing constraints 
 * and processing of <code> Auctions </code> and a Bidding Batch OSID for 
 * managing <code> Bids </code> and <code> Auctions </code> in bulk. </p>
 * 
 * <br/><hr/><br/>
 * 
 * <p>Copyright &copy; 2010 Ingenescus. All Rights Reserved. </p>
 * 
 * <p>This Work is being provided by the copyright holder(s) subject to the 
 * following license. By obtaining, using and/or copying this Work, you agree 
 * that you have read, understand, and will comply with the following terms 
 * and conditions. </p> 
 * 
 * <p> Permission to use, copy and distribute unmodified versions of this 
 * Work, for any purpose, without fee or royalty is hereby granted, provided 
 * that you include the above copyright notices and the terms of this license 
 * on ALL copies of the Work or portions thereof. </p> 
 * 
 * <p> You may nodify or create Derivatives of this Work only for your 
 * internal purposes. You shall not distribute or transfer any such Derivative 
 * of this Work to any location or to any third party. For the purposes of 
 * this license, "Derivative" shall mean any derivative of the Work as defined 
 * in the United States Copyright Act of 1976, such as a translation or 
 * modification. </p> 
 * 
 * <p> This Work and the information contained herein is provided on an "AS 
 * IS" basis WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT 
 * NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN 
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
 * CONNECTION WITH THE WORK OR THE USE OR OTHER DEALINGS IN THE WORK. </p> 
 * 
 * <p> The export of software employing encryption technology may require a 
 * specific license from the United States Government. It is the 
 * responsibility of any person or organization contemplating export to obtain 
 * such a license before exporting this Work. </p>
 */

package org.osid.bidding;
