/**
 * <p>The Open Service Interface Definitions for the org.osid.bidding.rules
 * service.</p>
 * 
 * <p>The Auction Rules OSID includes rules services to manage rules applied 
 * to <code> Auctions. </code> </p> 
 * <h4> AuctionConstrainer Rule </h4> 
 * 
 * <p> An <code> AuctionConstrainer </code> is an <code> OsidRule </code> that 
 * manages bidding constraints <code> Auction. </code> </p> 
 * <h4> AuctionConstrainerEnabler Rule </h4> 
 * 
 * <p> An <code> AuctionConstrainerEnabler </code> is an <code> OsidRule 
 * </code> that operates the enabling and disabling of an <code> 
 * AuctionConstrainer </code> through management of the <code> Auction </code> 
 * effective dates. An <code> AuctionConstrainerEnabler </code> may modify the 
 * effective dates of an <code> Auction </code> to make them effective at a 
 * fture time or expire them. An <code> AuctionConstrainerEnabler </code> that 
 * resurrects an expired <code> AuctionConstrainer </code> may create a new 
 * <code> AuctionConstrainer </code> with new effective dates to preserve the 
 * audit trail of effective <code> AuctionConstrainers. </code> </p> 
 * <h4> AuctionProcessor Rule </h4> 
 * 
 * <p> An <code> AuctionProcessorRule </code> is an <code> OsidRule </code> 
 * that manages the operation and processing of an <code> Auction. </code> 
 * </p> 
 * <h4> AuctionProcessorEnabler Rule </h4> 
 * 
 * <p> An <code> AuctionProcessorEnabler </code> is an <code> OsidRule </code> 
 * that operates the enabling and disabling of an <code> AuctionProcessor 
 * </code> through management of the <code> AuctionProcessor </code> effective 
 * dates. An <code> AuctionProcessorEnabler </code> may modify the effective 
 * dates of an <code> AuctionProcessor </code> to make them effective at a 
 * fture time or expire them. An <code> AuctionProcessorEnabler </code> that 
 * resurrects an expired <code> Auction </code> may create a new <code> 
 * AuctionProcessor </code> with new effective dates to preserve the audit 
 * trail of effective <code> AuctionProcessors. </code> </p> 
 * <h4> AuctionHouse Cataloging </h4> 
 * 
 * <p> <code> AuctionConstrainers, </code> <code> AuctionConstrainerEnablers, 
 * </code> <code> AuctionProcessors, </code> and <code> 
 * AuctionProcessorEnablers </code> are also cataloged in <code> 
 * AuctionHouses. </code> </p>
 * 
 * <br/><hr/><br/>
 * 
 * <p>Copyright &copy; 2011 Ingenescus. All Rights Reserved. </p>
 * 
 * <p>This Work is being provided by the copyright holder(s) subject to the 
 * following license. By obtaining, using and/or copying this Work, you agree 
 * that you have read, understand, and will comply with the following terms 
 * and conditions. </p> 
 * 
 * <p> Permission to use, copy and distribute unmodified versions of this 
 * Work, for any purpose, without fee or royalty is hereby granted, provided 
 * that you include the above copyright notices and the terms of this license 
 * on ALL copies of the Work or portions thereof. </p> 
 * 
 * <p> You may nodify or create Derivatives of this Work only for your 
 * internal purposes. You shall not distribute or transfer any such Derivative 
 * of this Work to any location or to any third party. For the purposes of 
 * this license, "Derivative" shall mean any derivative of the Work as defined 
 * in the United States Copyright Act of 1976, such as a translation or 
 * modification. </p> 
 * 
 * <p> This Work and the information contained herein is provided on an "AS 
 * IS" basis WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT 
 * NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN 
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
 * CONNECTION WITH THE WORK OR THE USE OR OTHER DEALINGS IN THE WORK. </p> 
 * 
 * <p> The export of software employing encryption technology may require a 
 * specific license from the United States Government. It is the 
 * responsibility of any person or organization contemplating export to obtain 
 * such a license before exporting this Work. </p>
 */

package org.osid.bidding.rules;
