/**
 * <p>The Open Service Interface Definitions for the org.osid.billing
 * service.</p>
 * 
 * <p>The Billing OSID manages billing for customers. </p> 
 * <h4> Customers </h4> 
 * 
 * <p> A <code> Customer </code> is a person known to the billing system. A 
 * <code> Customer </code> relates a <code> Resource </code> used to any 
 * business speciifc data defined in the <code> Customer. </code> </p> 
 * 
 * <p> <code> Customers </code> are <code> Temporal </code> with effective 
 * dates indicating their association with the business. </p> 
 * <h4> Periods </h4> 
 * 
 * <p> A <code> Period </code> is a billing period in which billing entries 
 * applies. <code> Periods </code> have a set of milestone dates including 
 * start and end of the billing period. </p> 
 * <h4> Items </h4> 
 * 
 * <p> An <code> Item </code> is something that can be billed. <code> Items 
 * </code> represent a one-time or recurring charge for some product or 
 * service. </p> 
 * 
 * <p> <code> Items </code> may relate to a <code> Product </code> in the 
 * Ordering OSID which manages the costs. <code> Items </code> may also relate 
 * to a general ledger <code> Account </code> in the Financials OSID. </p> 
 * <h4> Categories </h4> 
 * 
 * <p> <code> Items </code> can be categorized using a <code> Category. 
 * </code> <code> Categories </code> are used to group items on a billing 
 * statement. </p> 
 * <h4> Entries </h4> 
 * 
 * <p> An <code> Entry </code> is an <code> OsidRelationship </code> relating 
 * a <code> Customer </code> to an <code> Item </code> in a billing <code> 
 * Period. </code> An <code> Entry </code> captures the cost which may have 
 * been informed by the related Item. </p> 
 * <h4> Business Cataloging </h4> 
 * 
 * <p> <code> Customers, </code> <code> Items, </code> <code> Categories, 
 * </code> <code> Entries, </code> and <code> Periods </code> can be organized 
 * into federateble <code> Businesses. </code> </p> 
 * <h4> Orchestration </h4> 
 * 
 * <p> The Billing OSID can be orchestrated with an Ordering OSID to connect 
 * managed products and services to the billing system. Without the Ordering 
 * OSID, products and services may be managed directly using Items. </p> 
 * 
 * <p> The Billing OSID can also be orchestrated with a Financials OSID. 
 * <code> Customers </code> can be associated with financial Activities that 
 * collect their costs. <code> Items </code> can also be associated with G/L 
 * accounts to organize different types of products and services. </p> 
 * 
 * <p> The Billing OSID can also be orchestrated with the Commenting or 
 * Grading OSIDs for to indicate the <code> Customer </code> status and credit 
 * rating. </p> 
 * <h4> Sub Packages </h4> 
 * 
 * <p> The Billing OSID includes a Billing Payment OSID to track payments and 
 * a Billing Batch OSID to manage <code> Entries, </code> <code> Items, 
 * </code> <code> Periods, </code> <code> Customers, </code> and <code> 
 * Businesses </code> in bulk. </p>
 * 
 * <br/><hr/><br/>
 * 
 * <p>Copyright &copy; 2012 Ingenescus. All Rights Reserved. </p>
 * 
 * <p>This Work is being provided by the copyright holder(s) subject to the 
 * following license. By obtaining, using and/or copying this Work, you agree 
 * that you have read, understand, and will comply with the following terms 
 * and conditions. </p> 
 * 
 * <p> Permission to use, copy and distribute unmodified versions of this 
 * Work, for any purpose, without fee or royalty is hereby granted, provided 
 * that you include the above copyright notices and the terms of this license 
 * on ALL copies of the Work or portions thereof. </p> 
 * 
 * <p> You may modify or create Derivatives of this Work only for your 
 * internal purposes. You shall not distribute or transfer any such Derivative 
 * of this Work to any location or to any third party. For the purposes of 
 * this license, "Derivative" shall mean any derivative of the Work as defined 
 * in the United States Copyright Act of 1976, such as a translation or 
 * modification. </p> 
 * 
 * <p> This Work and the information contained herein is provided on an "AS 
 * IS" basis WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT 
 * NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN 
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
 * CONNECTION WITH THE WORK OR THE USE OR OTHER DEALINGS IN THE WORK. </p> 
 * 
 * <p> The export of software employing encryption technology may require a 
 * specific license from the United States Government. It is the 
 * responsibility of any person or organization contemplating export to obtain 
 * such a license before exporting this Work. </p>
 */

package org.osid.billing;
