/**
 * <p>The Open Service Interface Definitions for the org.osid.billing.payment
 * service.</p>
 * 
 * <p>The Billing Payment OSID manages billing payments. </p> 
 * <h4> Payers </h4> 
 * 
 * <p> A <code> Payer </code> is an entity that pays bills. A <code> Payer 
 * </code> a method of payment. <code> Customers </code> can have multiple 
 * <code> Payers </code> but a <code> Payer </code> is not required to relate 
 * to a <code> Customer. </code> A <code> Payer </code> may have its own 
 * identity through a <code> Resource. </code> </p> 
 * 
 * <p> <code> Payers </code> may have credit cards or bank account numbers on 
 * file for recurring payments. A <code> Payer </code> may also use the 
 * financial <code> Activity </code> referenced through the related <code> 
 * Customer. </code> </p> 
 * <h4> Payments </h4> 
 * 
 * <p> A <code> Payment </code> is an amount paid by a <code> Payer </code> 
 * for an amount owed by a <code> Customer. </code> Typically, the <code> 
 * Customer </code> for which the <code> Payment </code> applied is the same 
 * <code> Customer </code> related to the <code> Payer </code> but <code> 
 * Payments </code> may be applied to different <code> Customers. </code> </p> 
 * <h4> Sub Packages </h4> 
 * 
 * <p> The Billing Payment OSID contains a Billing Payment Batch OSID for 
 * making payments in bulk. </p>
 * 
 * <br/><hr/><br/>
 * 
 * <p>Copyright &copy; 2012 Ingenescus. All Rights Reserved. </p>
 * 
 * <p>This Work is being provided by the copyright holder(s) subject to the 
 * following license. By obtaining, using and/or copying this Work, you agree 
 * that you have read, understand, and will comply with the following terms 
 * and conditions. </p> 
 * 
 * <p> Permission to use, copy and distribute unmodified versions of this 
 * Work, for any purpose, without fee or royalty is hereby granted, provided 
 * that you include the above copyright notices and the terms of this license 
 * on ALL copies of the Work or portions thereof. </p> 
 * 
 * <p> You may modify or create Derivatives of this Work only for your 
 * internal purposes. You shall not distribute or transfer any such Derivative 
 * of this Work to any location or to any third party. For the purposes of 
 * this license, "Derivative" shall mean any derivative of the Work as defined 
 * in the United States Copyright Act of 1976, such as a translation or 
 * modification. </p> 
 * 
 * <p> This Work and the information contained herein is provided on an "AS 
 * IS" basis WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT 
 * NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN 
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
 * CONNECTION WITH THE WORK OR THE USE OR OTHER DEALINGS IN THE WORK. </p> 
 * 
 * <p> The export of software employing encryption technology may require a 
 * specific license from the United States Government. It is the 
 * responsibility of any person or organization contemplating export to obtain 
 * such a license before exporting this Work. </p>
 */

package org.osid.billing.payment;
