/**
 * <p>The Open Service Interface Definitions for the org.osid.blogging
 * service.</p>
 * 
 * <p>The Blogging OSID manages blogs. </p> 
 * <h4> Blog Entries </h4> 
 * 
 * <p> A blog <code> Entry </code> is an <code> OsidObject </code> which 
 * represents some text posted by an <code> Agent </code> and a timestamp. The 
 * blog <code> Entry </code> may include additional data available through its 
 * EntryRecord. </p> 
 * <h4> Cataloging </h4> 
 * 
 * <p> Blog entries are cataloged in <code> Blogs. </code> A single <code> 
 * Blog </code> may represent a set of entries posted by a single poster, or 
 * <code> Blogs </code> may be federated using the OSID hierarchy pattern to 
 * include a variety of blog entries across several posters. A <code> Blog 
 * </code> catalog may also provide a view of certain entries filteed by topic 
 * or date. </p> 
 * <h4> Posters </h4> 
 * 
 * <p> An <code> Agent </code> posts an <code> Entry. </code> The Blogging 
 * OSID also provides access to the related <code> Resource </code> of the 
 * posting <code> Agent </code> so that orchestration with a Resource OSID is 
 * unnecessary to normalize the authenticated identities where multiple <code> 
 * Agents </code> are in play. </p> 
 * <h4> Orchestration </h4> 
 * 
 * <p> The Blogging OSID may be orchestrated with the Process OSID to provide 
 * state management and/or the Ontology OSID to implement subject tagging. The 
 * OSID Blog may also be orchestrated with the Commenting OSID to provide a 
 * list of comments and ratings from other users as well as Commenting <code> 
 * Books </code> for tracking read blog entries for a specific user. </p> 
 * <h4> Sub Packages </h4> 
 * 
 * <p> The Blodding OSID contains a Blogging Batch OSID for managing <code> 
 * Blogs </code> and <code> Entries </code> in bulk. </p>
 * 
 * <br/><hr/><br/>
 * 
 * <p>Copyright &copy; 2010 Ingenescus. All Rights Reserved. </p>
 * 
 * <p>This Work is being provided by the copyright holder(s) subject to the 
 * following license. By obtaining, using and/or copying this Work, you agree 
 * that you have read, understand, and will comply with the following terms 
 * and conditions. </p> 
 * 
 * <p> Permission to use, copy and distribute unmodified versions of this 
 * Work, for any purpose, without fee or royalty is hereby granted, provided 
 * that you include the above copyright notices and the terms of this license 
 * on ALL copies of the Work or portions thereof. </p> 
 * 
 * <p> You may nodify or create Derivatives of this Work only for your 
 * internal purposes. You shall not distribute or transfer any such Derivative 
 * of this Work to any location or to any third party. For the purposes of 
 * this license, "Derivative" shall mean any derivative of the Work as defined 
 * in the United States Copyright Act of 1976, such as a translation or 
 * modification. </p> 
 * 
 * <p> This Work and the information contained herein is provided on an "AS 
 * IS" basis WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT 
 * NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN 
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
 * CONNECTION WITH THE WORK OR THE USE OR OTHER DEALINGS IN THE WORK. </p> 
 * 
 * <p> The export of software employing encryption technology may require a 
 * specific license from the United States Government. It is the 
 * responsibility of any person or organization contemplating export to obtain 
 * such a license before exporting this Work. </p>
 */

package org.osid.blogging;
