/**
 * <p>The Open Service Interface Definitions for the org.osid.calendaring.cycle
 * service.</p>
 * 
 * <p>The Calendaring Cycle OSID manages canonical versions of events and time 
 * periods. This package does not define the rules to automatically generate 
 * events and time periods. This package sits in between the Calendaring OSID 
 * and the Calendaring Mason OSID where rules for generation are defined. </p> 
 * 
 * <p> This package defines <code> CyclicEvents </code> and <code> 
 * CyclicTimePeriods. </code> An example of a <code> CyclicEvent </code> is 
 * "Thanksgiving" or "Quarterly Report Deadline" that occurs at predicatble 
 * intervals. An example of a <code> CyclicTimePeriod </code> is "Fiscal Q4" 
 * or "Fall Term." </p> 
 * 
 * <p> This package can be positioned either or both of two ways: </p> 
 * 
 * <ul>
 *     <li> Defining and mapping existing <code> Events </code> and <code> 
 *     TimePeriods </code> to these canonical counterparts for the purposes of 
 *     defining rules in other OSIDs that manage a recurring behavior, such as 
 *     an <code> OsidEnabler. </code> </li> 
 *     <li> Defining rules behind <code> CyclicEvents </code> and <code> 
 *     CyclicTimePeriods </code> inthe Calendaring Mason OSID to centrally 
 *     manage the automatic generation of <code> Events </code> and <code> 
 *     TimePeriods </code> in the Calendaring OSID. Not for the faint of 
 *     heart. </li> 
 * </ul>
 * 
 * <h4> Calendaring Catalogging </h4> 
 * 
 * <p> <code> CyclicEvents </code> and <code> CyclicTimePreiods </code> are 
 * organized into federateable <code> Calendars. </code> </p> 
 * <h4> Sub Packages </h4> 
 * 
 * <p> The Calendaring Cycle OSID contains a Calendaring cycle Batch OSID for 
 * managing time cycles in bulk. </p>
 * 
 * <br/><hr/><br/>
 * 
 * <p>Copyright &copy; 2011 Ingenescus. All Rights Reserved. </p>
 * 
 * <p>This Work is being provided by the copyright holder(s) subject to the 
 * following license. By obtaining, using and/or copying this Work, you agree 
 * that you have read, understand, and will comply with the following terms 
 * and conditions. </p> 
 * 
 * <p> Permission to use, copy and distribute unmodified versions of this 
 * Work, for any purpose, without fee or royalty is hereby granted, provided 
 * that you include the above copyright notices and the terms of this license 
 * on ALL copies of the Work or portions thereof. </p> 
 * 
 * <p> You may nodify or create Derivatives of this Work only for your 
 * internal purposes. You shall not distribute or transfer any such Derivative 
 * of this Work to any location or to any third party. For the purposes of 
 * this license, "Derivative" shall mean any derivative of the Work as defined 
 * in the United States Copyright Act of 1976, such as a translation or 
 * modification. </p> 
 * 
 * <p> This Work and the information contained herein is provided on an "AS 
 * IS" basis WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT 
 * NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN 
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
 * CONNECTION WITH THE WORK OR THE USE OR OTHER DEALINGS IN THE WORK. </p> 
 * 
 * <p> The export of software employing encryption technology may require a 
 * specific license from the United States Government. It is the 
 * responsibility of any person or organization contemplating export to obtain 
 * such a license before exporting this Work. </p>
 */

package org.osid.calendaring.cycle;
