/**
 * <p>The Open Service Interface Definitions for the org.osid.cataloging
 * service.</p>
 * 
 * <p>The Cataloging OSID is an auxiliary service and provides a means for 
 * organizing <code> OsidObjects </code> into <code> OsidCatalogs. </code> An 
 * <code> OsidObject </code> is represented by an OSID <code> Id. </code> </p> 
 * 
 * <p> <code> Catalogs </code> can be organized into hierarchies for 
 * federation. A <code> Catalog </code> that is a parent of another catalog 
 * includes the <code> Ids </code> of its children. </p> 
 * 
 * <p> The Cataloging OSID provides the core definition for the cataloging 
 * functions used throughout the OSIDs and aids in the adaptability of 
 * cataloging structures. </p> 
 * <h4> Sub Packages </h4> 
 * 
 * <p> The Cataloging OSID includes a rules package for managing the behavior 
 * of a <code> Catalog </code> in a federated hierarchy. </p>
 * 
 * <br/><hr/><br/>
 * 
 * <p>Copyright &copy; 2006-2007 Massachusetts Institute of Technology. </p> 
 * 
 * <p> Copyright &copy; 2010 Ingenescus. All Rights Reserved. </p>
 * 
 * <p>This Work is being provided by the copyright holder(s) subject to the 
 * following license. By obtaining, using and/or copying this Work, you agree 
 * that you have read, understand, and will comply with the following terms 
 * and conditions. </p> 
 * 
 * <p> Permission to use, copy and distribute unmodified versions of this 
 * Work, for any purpose, without fee or royalty is hereby granted, provided 
 * that you include the above copyright notices and the terms of this license 
 * on ALL copies of the Work or portions thereof. </p> 
 * 
 * <p> You may nodify or create Derivatives of this Work only for your 
 * internal purposes. You shall not distribute or transfer any such Derivative 
 * of this Work to any location or to any third party. For the purposes of 
 * this license, "Derivative" shall mean any derivative of the Work as defined 
 * in the United States Copyright Act of 1976, such as a translation or 
 * modification. </p> 
 * 
 * <p> This Work and the information contained herein is provided on an "AS 
 * IS" basis WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT 
 * NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN 
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
 * CONNECTION WITH THE WORK OR THE USE OR OTHER DEALINGS IN THE WORK. </p> 
 * 
 * <p> The export of software employing encryption technology may require a 
 * specific license from the United States Government. It is the 
 * responsibility of any person or organization contemplating export to obtain 
 * such a license before exporting this Work. </p>
 */

package org.osid.cataloging;
