/**
 * <p>The Open Service Interface Definitions for the org.osid.checklist
 * service.</p>
 * 
 * <p>The Checklist OSID provides a means of managing action items. </p> 
 * <h4> Todos </h4> 
 * 
 * <p> A <code> Todo </code> is a <code> Temporal </code> item that appears on 
 * a <code> Checklist. </code> The effective dats of aa <code> Todo </code> 
 * determine when the <code> Todo </code> is actively on the list. An 
 * ineffective <code> Todo </code> may be due the the completion or the 
 * skipping of the item. </p> 
 * 
 * <p> A Todo may depend on one or more other Todos to help with determining 
 * an order of tackling the action items in addition the sequencing and 
 * prioritization of the items. </p> 
 * 
 * <p> <code> Todos </code> are hierarchical to support nested action items. A 
 * parent <code> Todo </code> is not completed until all child <code> Todos 
 * </code> are completed. </p> 
 * <h4> Checklist Cataloging </h4> 
 * 
 * <p> <code> Todos </code> are cataloged in <code> Checklists </code> which 
 * may also be grouped hierarchically to federate multiple collections of 
 * <code> Todos. </code> </p> 
 * <h4> Sub Packages </h4> 
 * 
 * <p> The Checklist OSID contains a Checklist Mason OSID to manage the 
 * automatic creation of <code> Todos. </code> <code> Todos </code> may be 
 * created based on a cyclic event managed in the Calendaring Cyclic OSID or 
 * in response to a threshold in the Inventory OSID. </p>
 * 
 * <br/><hr/><br/>
 * 
 * <p>Copyright &copy; 2010 Ingenescus. All Rights Reserved. </p>
 * 
 * <p>This Work is being provided by the copyright holder(s) subject to the 
 * following license. By obtaining, using and/or copying this Work, you agree 
 * that you have read, understand, and will comply with the following terms 
 * and conditions. </p> 
 * 
 * <p> Permission to use, copy and distribute unmodified versions of this 
 * Work, for any purpose, without fee or royalty is hereby granted, provided 
 * that you include the above copyright notices and the terms of this license 
 * on ALL copies of the Work or portions thereof. </p> 
 * 
 * <p> You may nodify or create Derivatives of this Work only for your 
 * internal purposes. You shall not distribute or transfer any such Derivative 
 * of this Work to any location or to any third party. For the purposes of 
 * this license, "Derivative" shall mean any derivative of the Work as defined 
 * in the United States Copyright Act of 1976, such as a translation or 
 * modification. </p> 
 * 
 * <p> This Work and the information contained herein is provided on an "AS 
 * IS" basis WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT 
 * NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN 
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
 * CONNECTION WITH THE WORK OR THE USE OR OTHER DEALINGS IN THE WORK. </p> 
 * 
 * <p> The export of software employing encryption technology may require a 
 * specific license from the United States Government. It is the 
 * responsibility of any person or organization contemplating export to obtain 
 * such a license before exporting this Work. </p>
 */

package org.osid.checklist;
