/**
 * <p>The Open Service Interface Definitions for the org.osid.contact
 * service.</p>
 * 
 * <p>The Contact OSID is an auxiliary service that relates contact 
 * information to <code> OsidObjects. </code> </p> 
 * <h4> Addresses </h4> 
 * 
 * <p> An <code> Address </code> is an <code> OsidObject </code> for a the 
 * address of a <code> Resource. </code> Specific breakdowns of an <code> 
 * Address </code> may be made available in an <code> AddressRecord </code> 
 * but and the <code> Address </code> exposes a text form of the address. </p> 
 * <h4> Contacts </h4> 
 * 
 * <p> A <code> Contact </code> is an <code> OsidRelationship </code> between 
 * an <code> Address </code> and a reference <code> Id </code> <code> Contacts 
 * </code> are time-variant which allow <code> Addresses </code> to become 
 * effective based on schedules. </p> 
 * 
 * <p> <code> Contacts </code> have an addressee. Addressees are <code> 
 * Resources </code> that indicate to whom or what should be contacted. In the 
 * case of making contacts for external <code> Resources, </code> the 
 * reference <code> Id </code> and the addressee <code> Resource </code> 
 * <code> Id </code> may be the same. </p> 
 * <h4> Example </h4> 
 * 
 * <p> An <code> Address </code> exists for Tom: tom@earth.com. An OSID 
 * Consumer wishing to contact Tom does by looking up effective <code> 
 * Contacts </code> for Tom as a reference and then retrieving the related 
 * <code> Addresses </code> for the <code> Contacts. </code> </p> 
 * 
 * <p> An <code> Contact </code> exists for a startup company (reference) 
 * where the addressee is Scott with an <code> Address </code> at 162 School 
 * Street. Another <code> Contact </code> exists with an addressee for Sarah 
 * also with an <code> Address </code> at 162 School Street. A single <code> 
 * Address </code> can be used for 162 School Street with an address <code> 
 * Resource </code> of Scott &amp; Sarah's House. Gypsy can be added by 
 * creating a <code> Contact </code> referencing the dog related to the same 
 * <code> Address. </code> </p> 
 * <h4> Address Book Cataloging </h4> 
 * 
 * <p> <code> Addresses </code> and <code> Contacts </code> can be organized 
 * into federateable <code> AddressBooks. </code> </p> 
 * <h4> Sub Packages </h4> 
 * 
 * <p> The Contact OSID includes a rules subpackage for managing the effective 
 * status of <code> Contacts </code> and a Contact Batch OSID for managing 
 * <code> Contacts </code> and <code> Addresses </code> in bulk. </p>
 * 
 * <br/><hr/><br/>
 * 
 * <p>Copyright &copy; 2010 Ingenescus. All Rights Reserved. </p>
 * 
 * <p>This Work is being provided by the copyright holder(s) subject to the 
 * following license. By obtaining, using and/or copying this Work, you agree 
 * that you have read, understand, and will comply with the following terms 
 * and conditions. </p> 
 * 
 * <p> Permission to use, copy and distribute unmodified versions of this 
 * Work, for any purpose, without fee or royalty is hereby granted, provided 
 * that you include the above copyright notices and the terms of this license 
 * on ALL copies of the Work or portions thereof. </p> 
 * 
 * <p> You may nodify or create Derivatives of this Work only for your 
 * internal purposes. You shall not distribute or transfer any such Derivative 
 * of this Work to any location or to any third party. For the purposes of 
 * this license, "Derivative" shall mean any derivative of the Work as defined 
 * in the United States Copyright Act of 1976, such as a translation or 
 * modification. </p> 
 * 
 * <p> This Work and the information contained herein is provided on an "AS 
 * IS" basis WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT 
 * NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN 
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
 * CONNECTION WITH THE WORK OR THE USE OR OTHER DEALINGS IN THE WORK. </p> 
 * 
 * <p> The export of software employing encryption technology may require a 
 * specific license from the United States Government. It is the 
 * responsibility of any person or organization contemplating export to obtain 
 * such a license before exporting this Work. </p>
 */

package org.osid.contact;
