/**
 * <p>The Open Service Interface Definitions for the org.osid.course.program
 * service.</p>
 * 
 * <p>The Course Program OSID provides course management services for 
 * programs. </p> 
 * <h4> Programs </h4> 
 * 
 * <p> The <code> Program </code> is a canonical learning unit describing the 
 * overall content of a program, completon requirements, and earned 
 * credentials. </p> 
 * 
 * <p> <code> Courses </code> may be associated with <code> Programs </code> . 
 * but completion requirements are managed in the Course Requisite OSID. </p> 
 * <h4> ProgramOfferings </h4> 
 * 
 * <p> A <code> ProgramOffering </code> is a canonical <code> Program </code> 
 * offered for a <code> Term. </code> <code> ProgramOffering </code> 
 * replicates some of the data managed in the <code> Program </code> in the 
 * case it is refined or tweaked. The purpose of the <code> ProgramOffering 
 * </code> is to define the <code> Term </code> in which students may enroll 
 * in a Program. While a <code> Program </code> may span several <code> Terms, 
 * </code> the offering tracks when the student enrolled for the purpose of 
 * relating the completion requirements at a point in time. </p> 
 * <h4> Enrollment </h4> 
 * 
 * <p> The <code> Enrollment </code> is an <code> OsidRelationship </code> 
 * between a student and a <code> ProgramOffering. </code> For multi-term 
 * <code> Programs, </code> the <code> Enrollment </code> may continue beyond 
 * the <code> Term </code> of the <code> ProgramOffering </code> since the 
 * <code> Term </code> indicates what requirements are applied to the student. 
 * </p> 
 * <h4> Credentials </h4> 
 * 
 * <p> A <code> Credential </code> is a something awarded to the student at 
 * the completion of a <code> Program. </code> </p> 
 * <h4> Course Catalog Cataloging </h4> 
 * 
 * <p> <code> Programs, </code> <code> ProgramOfferings, </code> <code> 
 * Enrollments, </code> and <code> Credentials </code> can be organized into 
 * federateble <code> OsidCatalogs. </code> </p> 
 * <h4> Sub Packages </h4> 
 * 
 * <p> The Course Program Batch OSID contains a Course Program Batch OSID for 
 * managing <code> Programs, </code> <code> Credentials, </code> <code> 
 * ProgramOfferings, </code> and <code> Enrollments </code> in bulk. </p>
 * 
 * <br/><hr/><br/>
 * 
 * <p>Copyright &copy; 2010 Ingenescus. All Rights Reserved. </p>
 * 
 * <p>This Work is being provided by the copyright holder(s) subject to the 
 * following license. By obtaining, using and/or copying this Work, you agree 
 * that you have read, understand, and will comply with the following terms 
 * and conditions. </p> 
 * 
 * <p> Permission to use, copy and distribute unmodified versions of this 
 * Work, for any purpose, without fee or royalty is hereby granted, provided 
 * that you include the above copyright notices and the terms of this license 
 * on ALL copies of the Work or portions thereof. </p> 
 * 
 * <p> You may modify or create Derivatives of this Work only for your 
 * internal purposes. You shall not distribute or transfer any such Derivative 
 * of this Work to any location or to any third party. For the purposes of 
 * this license, "Derivative" shall mean any derivative of the Work as defined 
 * in the United States Copyright Act of 1976, such as a translation or 
 * modification. </p> 
 * 
 * <p> This Work and the information contained herein is provided on an "AS 
 * IS" basis WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT 
 * NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN 
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
 * CONNECTION WITH THE WORK OR THE USE OR OTHER DEALINGS IN THE WORK. </p> 
 * 
 * <p> The export of software employing encryption technology may require a 
 * specific license from the United States Government. It is the 
 * responsibility of any person or organization contemplating export to obtain 
 * such a license before exporting this Work. </p>
 */

package org.osid.course.program;
