/**
 * <p>The Open Service Interface Definitions for the org.osid.financials
 * service.</p>
 * 
 * <p>The Financials OSID provides management of financial data through G/L 
 * accounts, activity accounts, budgeting, and posting transactions. </p> 
 * <h4> Account </h4> 
 * 
 * <p> An <code> Account </code> is an account of the General Ledger. G/L 
 * <code> Accounts </code> are hierarchical to define more granular accounts. 
 * Root level accounts generally map to the top-level accounting equation. 
 * </p> 
 * <h4> Activity </h4> 
 * 
 * <p> An <code> Activity </code> is a view of the General Ledger from an 
 * activity or organizational perspective. An <code> Activity </code> contains 
 * one or more <code> Accounts </code> from the General Ledger. Activities are 
 * also hierarchical and may be used to map to a financial organizational 
 * hierarchy. </p> 
 * <h4> Fiscal Period </h4> 
 * 
 * <p> A <code> FiscalPeriod </code> is a period of time used to capture 
 * transactions and perform reporting. Generally, a fiscal period is a fiscal 
 * quarter or year. </p> 
 * <h4> Business Cataloging </h4> 
 * 
 * <p> <code> Accounts, </code> <code> Activities, </code> and <code> 
 * FiscalPeriods </code> are organized into federaable <code> Businesses. 
 * </code> </p> 
 * <h4> Sub Packages </h4> 
 * 
 * <p> The Fincncials OSID defines a Financials Budgeting OSID for managing 
 * budgets, a Financials Posting OSID for posting financial transactions, and 
 * a FInancials Batch OSID for performing bulk operations. </p>
 * 
 * <br/><hr/><br/>
 * 
 * <p>Copyright &copy; 2012 Ingenescus. All Rights Reserved. </p>
 * 
 * <p>This Work is being provided by the copyright holder(s) subject to the 
 * following license. By obtaining, using and/or copying this Work, you agree 
 * that you have read, understand, and will comply with the following terms 
 * and conditions. </p> 
 * 
 * <p> Permission to use, copy and distribute unmodified versions of this 
 * Work, for any purpose, without fee or royalty is hereby granted, provided 
 * that you include the above copyright notices and the terms of this license 
 * on ALL copies of the Work or portions thereof. </p> 
 * 
 * <p> You may modify or create Derivatives of this Work only for your 
 * internal purposes. You shall not distribute or transfer any such Derivative 
 * of this Work to any location or to any third party. For the purposes of 
 * this license, "Derivative" shall mean any derivative of the Work as defined 
 * in the United States Copyright Act of 1976, such as a translation or 
 * modification. </p> 
 * 
 * <p> This Work and the information contained herein is provided on an "AS 
 * IS" basis WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT 
 * NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN 
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
 * CONNECTION WITH THE WORK OR THE USE OR OTHER DEALINGS IN THE WORK. </p> 
 * 
 * <p> The export of software employing encryption technology may require a 
 * specific license from the United States Government. It is the 
 * responsibility of any person or organization contemplating export to obtain 
 * such a license before exporting this Work. </p>
 */

package org.osid.financials;
