/**
 * <p>The Open Service Interface Definitions for the org.osid.forum
 * service.</p>
 * 
 * <p>The Forum OSID defines threaded diiscussion groups managing a set of 
 * posts and replies. </p> 
 * <h4> Posts </h4> 
 * 
 * <p> A <code> Post </code> is an <code> OsidObject </code> that defines some 
 * text, a timestamp, and a poster. </p> 
 * <h4> Replies </h4> 
 * 
 * <p> A <code> Reply </code> is similar to a <code> Post </code> but is in 
 * response to either a <code> Post </code> or another <code> Reply. </code> A 
 * <code> Reply </code> is a <code> Containable </code> making directly 
 * accessible any nested <code> Replies </code> outside of the session. </p> 
 * <h4> Posters </h4> 
 * 
 * <p> An <code> Agent </code> posts to a <code> Forum </code> or an <code> 
 * Agent </code> replies to a <code> Post. </code> The relationship between 
 * the <code> Agent </code> and its associated <code> Resource </code> is 
 * orchestrated within the Forum OSID. <code> Posts </code> and <code> Replies 
 * </code> reveal both the posting <code> Agent </code> and the associated 
 * poster <code> Resource. </code> </p> 
 * <h4> Forum Catalogs </h4> 
 * 
 * <p> Forums represent collections of <code> Posts. </code> Forums may be 
 * created through federation or by selecting <code> Posts </code> based on 
 * their attributes to create a virtual catalog of Posts. <code> Replies 
 * </code> are always associated with their <code> Posts </code> and may not 
 * be cataloged independently. </p> 
 * <h4> Sub Packages </h4> 
 * 
 * <p> The Forum OSID contains a Forum Batch OSID for managing <code> Posts 
 * </code> and <code> Replies </code> in bulk. </p>
 * 
 * <br/><hr/><br/>
 * 
 * <p>Copyright &copy; 2010 Ingenescus. All Rights Reserved. </p>
 * 
 * <p>This Work is being provided by the copyright holder(s) subject to the 
 * following license. By obtaining, using and/or copying this Work, you agree 
 * that you have read, understand, and will comply with the following terms 
 * and conditions. </p> 
 * 
 * <p> Permission to use, copy and distribute unmodified versions of this 
 * Work, for any purpose, without fee or royalty is hereby granted, provided 
 * that you include the above copyright notices and the terms of this license 
 * on ALL copies of the Work or portions thereof. </p> 
 * 
 * <p> You may nodify or create Derivatives of this Work only for your 
 * internal purposes. You shall not distribute or transfer any such Derivative 
 * of this Work to any location or to any third party. For the purposes of 
 * this license, "Derivative" shall mean any derivative of the Work as defined 
 * in the United States Copyright Act of 1976, such as a translation or 
 * modification. </p> 
 * 
 * <p> This Work and the information contained herein is provided on an "AS 
 * IS" basis WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT 
 * NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN 
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
 * CONNECTION WITH THE WORK OR THE USE OR OTHER DEALINGS IN THE WORK. </p> 
 * 
 * <p> The export of software employing encryption technology may require a 
 * specific license from the United States Government. It is the 
 * responsibility of any person or organization contemplating export to obtain 
 * such a license before exporting this Work. </p>
 */

package org.osid.forum;
