/**
 * <p>The Open Service Interface Definitions for the org.osid.id
 * service.</p>
 * 
 * <p>The Id OSID provides the means for creating and mapping identifiers. All 
 * OSID objects are identified by a unique and immutable <code> Id. </code> 
 * The <code> Id </code> OSID can be used to generate new <code> Ids </code> 
 * when creating new objects. </p> 
 * 
 * <p> Consumers wishing to persist an OSID object should instead persist the 
 * reference to the object by serializing the <code> Id. </code> </p> 
 * 
 * <p> <code> </code> Most OSID interfaces are used to encapsulate 
 * implementation-specific objects from provider to consumer. <code> Id 
 * </code> is an <code> OsidPrimitive </code> and as such cannot be used to 
 * encapsulate implementation-specific data other than what is defined 
 * explicitly in the <code> Id. </code> An OSID Provider must respect any 
 * <code> Id </code> based on its interface alone. </p> 
 * 
 * <p> The Id service can be used to assign Ids for an OSID Provider or be 
 * used to manage Id translations for system to system compatibility. </p> 
 * 
 * <p> The <code> Id </code> service can also be used as a means to map one 
 * identifier to another when an object is known by multiple identifiers. 
 * Mapping identifier spaces is often a critical part of interoperability and 
 * the Id service can be used as a shim to bridge different systems. </p> 
 * <h4> Id Mapping Example </h4> 
 * 
 * <pre>
 *      
 *      
 *      public Asset getAsset(assetId) {
 *          Id id = idSession.getId(assetId);
 *          return (other_impl.getAsset(assetId));
 *      }
 *      
 *              
 *      
 * </pre>
 * 
 * 
 * <br/><hr/><br/>
 * 
 * <p>Copyright &copy; 2002, 2006 Massachusetts Institute of Technology. All 
 * Rights Reserved. </p>
 * 
 * <p>This Work is being provided by the copyright holder(s) subject to the 
 * following license. By obtaining, using and/or copying this Work, you agree 
 * that you have read, understand, and will comply with the following terms 
 * and conditions. </p> 
 * 
 * <p> Permission to use, copy and distribute unmodified versions of this 
 * Work, for any purpose, without fee or royalty is hereby granted, provided 
 * that you include the above copyright notices and the terms of this license 
 * on ALL copies of the Work or portions thereof. </p> 
 * 
 * <p> You may modify or create Derivatives of this Work only for your 
 * internal purposes. You shall not distribute or transfer any such Derivative 
 * of this Work to any location or to any third party. For the purposes of 
 * this license, "Derivative" shall mean any derivative of the Work as defined 
 * in the United States Copyright Act of 1976, such as a translation or 
 * modification. </p> 
 * 
 * <p> This Work and the information contained herein is provided on an "AS 
 * IS" basis WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT 
 * NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN 
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
 * CONNECTION WITH THE WORK OR THE USE OR OTHER DEALINGS IN THE WORK. </p> 
 * 
 * <p> The export of software employing encryption technology may require a 
 * specific license from the United States Government. It is the 
 * responsibility of any person or organization contemplating export to obtain 
 * such a license before exporting this Work. </p>
 */

package org.osid.id;
