/**
 * <p>The Open Service Interface Definitions for the org.osid.inventory
 * service.</p>
 * 
 * <p>The Inventory OSID provides the service of managing inventories of 
 * things. </p> 
 * <h4> Items </h4> 
 * 
 * <p> <code> Items </code> are individual assets tracked with a serial 
 * number. <code> Items </code> may have a location and may be accounted as a 
 * part of another <code> Item. </code> <code> Items </code> belong to a 
 * <code> Stock </code> . </p> 
 * <h4> Stocks </h4> 
 * 
 * <p> A <code> Stock </code> is a collection of Items. <code> Stocks </code> 
 * have a stock keeping unit and may also have a location. <code> Stocks 
 * </code> are also hierarchical. </p> 
 * <h4> Model </h4> 
 * 
 * <p> A Model is used to normalize a product vendor and model across <code> 
 * Stocks </code> . </p> 
 * <h4> Example </h4> 
 * 
 * <p> A <code> Stock </code> may be used to represent a stockpile of dynamite 
 * of <code> Model </code> Acme Dynamite #7. Each <code> Item </code> 
 * represents a stick of dynamite. </p> 
 * <h4> Inventories </h4> 
 * 
 * <p> An <code> Inventory </code> is a snapshot of the quantity of <code> 
 * Items </code> in a <code> Stock. </code> <code> Inventories </code> may be 
 * tracked over time. </p> 
 * <h4> Warehouse Cataloging </h4> 
 * 
 * <p> <code> Items, </code> <code> Stocks, </code> <code> Models, </code> and 
 * <code> Inventories </code> may be cataloged into federateable <code> 
 * Warehouses. </code> </p> 
 * <h4> Sub Packages </h4> 
 * 
 * <p> The Inventory OSID includes an Inventory Shipment OSID for transferring 
 * <code> Items </code> to and from <code> Stocks </code> and an Inventory 
 * Batch OSID for managing inventory in bulk. </p>
 * 
 * <br/><hr/><br/>
 * 
 * <p>Copyright &copy; 2011 Ingenescus. All Rights Reserved. </p>
 * 
 * <p>This Work is being provided by the copyright holder(s) subject to the 
 * following license. By obtaining, using and/or copying this Work, you agree 
 * that you have read, understand, and will comply with the following terms 
 * and conditions. </p> 
 * 
 * <p> Permission to use, copy and distribute unmodified versions of this 
 * Work, for any purpose, without fee or royalty is hereby granted, provided 
 * that you include the above copyright notices and the terms of this license 
 * on ALL copies of the Work or portions thereof. </p> 
 * 
 * <p> You may nodify or create Derivatives of this Work only for your 
 * internal purposes. You shall not distribute or transfer any such Derivative 
 * of this Work to any location or to any third party. For the purposes of 
 * this license, "Derivative" shall mean any derivative of the Work as defined 
 * in the United States Copyright Act of 1976, such as a translation or 
 * modification. </p> 
 * 
 * <p> This Work and the information contained herein is provided on an "AS 
 * IS" basis WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT 
 * NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN 
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
 * CONNECTION WITH THE WORK OR THE USE OR OTHER DEALINGS IN THE WORK. </p> 
 * 
 * <p> The export of software employing encryption technology may require a 
 * specific license from the United States Government. It is the 
 * responsibility of any person or organization contemplating export to obtain 
 * such a license before exporting this Work. </p>
 */

package org.osid.inventory;
