//
// org.osid.mapping.path.rules.SpeedZoneEnablerSearchResults
//
//     The OSID Java specification for org.osid.mapping.path.rules.SpeedZoneEnablerSearchResults.
//
// Copyright (C) 2011 Ingenescus. All Rights Reserved. 
//
//     This Work is being provided by the copyright holder(s) subject to the 
//     following license. By obtaining, using and/or copying this Work, you 
//     agree that you have read, understand, and will comply with the 
//     following terms and conditions. 
//     
//     Permission to use, copy and distribute unmodified versions of this 
//     Work, for any purpose, without fee or royalty is hereby granted, 
//     provided that you include the above copyright notices and the terms of 
//     this license on ALL copies of the Work or portions thereof. 
//     
//     You may nodify or create Derivatives of this Work only for your 
//     internal purposes. You shall not distribute or transfer any such 
//     Derivative of this Work to any location or to any third party. For the 
//     purposes of this license, "Derivative" shall mean any derivative of the 
//     Work as defined in the United States Copyright Act of 1976, such as a 
//     translation or modification. 
//     
//     This Work and the information contained herein is provided on an "AS 
//     IS" basis WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING 
//     BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A 
//     PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS 
//     OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
//     LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
//     FROM, OUT OF OR IN CONNECTION WITH THE WORK OR THE USE OR OTHER 
//     DEALINGS IN THE WORK. 
//     
//     The export of software employing encryption technology may require a 
//     specific license from the United States Government. It is the 
//     responsibility of any person or organization contemplating export to 
//     obtain such a license before exporting this Work. 
//

package org.osid.mapping.path.rules;


/**
 *  <p>This interface provides a means to capture results of a search. </p>
 */

public interface SpeedZoneEnablerSearchResults
    extends org.osid.OsidSearchResults {


    /**
     *  Gets the <code> SpeedZoneEnablerList </code> resulting from a search. 
     *
     *  @return the speed zone enabler list 
     *  @throws org.osid.IllegalStateException list has already been retrieved 
     *  @compliance mandatory This method must be implemented. 
     */

    public org.osid.mapping.path.rules.SpeedZoneEnablerList getSpeedZoneEnablers();


    /**
     *  Gets the inspector for the query to examine the terms used in the 
     *  search. 
     *
     *  @return the speed zone enabler query inspector 
     *  @compliance mandatory This method must be implemented. 
     */

    public org.osid.mapping.path.rules.SpeedZoneEnablerQueryInspector getSpeedZoneEnablerQueryInspector();


    /**
     *  Gets the speed zone enabler search results record corresponding to the 
     *  given speed zone enabler search record <code> Type. </code> This 
     *  method must be used to retrieve an object implementing the requested 
     *  record. 
     *
     *  @param  speedZoneEnablerSearchRecordType a speed zone enabler search 
     *          record type 
     *  @return the speed zone enabler search results record 
     *  @throws org.osid.NullArgumentException <code> 
     *          speedZoneEnablerSearchRecordType </code> is <code> null 
     *          </code> 
     *  @throws org.osid.OperationFailedException unable to complete request 
     *  @throws org.osid.PermissionDeniedException authorization failure 
     *          occurred 
     *  @throws org.osid.UnsupportedException <code> 
     *          hasRecordType(speedZoneEnablerSearchRecordType) </code> is 
     *          <code> false </code> 
     *  @compliance mandatory This method must be implemented. 
     */

    public org.osid.mapping.path.rules.records.SpeedZoneEnablerSearchResultsRecord getSpeedZoneEnablerSearchResultsRecord(org.osid.type.Type speedZoneEnablerSearchRecordType)
        throws org.osid.OperationFailedException,
               org.osid.PermissionDeniedException;
}
