package org.osid.meta;

/**
 *  Loads and stores the OSIDs.
 *
 *  Generated by the Java Meta OSID Binder at Fri Jun 20 12:32:34 EDT 2014
 */

public class OsidInterfaces {
    private static final java.util.Map<String, OsidInterface> interfaces     = java.util.Collections.synchronizedMap(new java.util.HashMap<String, OsidInterface>());
    private static final java.util.Map<String, OsidEnumeration> enumerations = java.util.Collections.synchronizedMap(new java.util.HashMap<String, OsidEnumeration>());


    /**
     *  Looks up an OSID interface by name.
     *
     *  @param name name of an OSID interface
     *  @return an <code>OsidInterface</code> or <code>null</code>
     *          if not found
     */

    public static OsidInterface getInterface(String name) {
        return (interfaces.get(name));
    }


    /**
     *  Looks up OSID interfaces by OSID.
     *
     *  @return a list of OSID interfaces
     */

    public static java.util.Collection<OsidInterface> getInterfaces() {
        return (interfaces.values());
    }


    /**
     *  Adds an OSID interface.
     *
     *  @param iface an OSID interface
     */

    protected static void addInterface(OsidInterface iface) {
        interfaces.put(iface.getName(), iface);
        return;
    }


    /**
     *  Looks up an OSID enumeration by name.
     *
     *  @param name name of an OSID interface
     *  @return an <code>OsidEnumeration</code> or <code>null</code>
     *          if not found
     */

    public static OsidEnumeration getEnumeration(String name) {
        return (enumerations.get(name));
    }


    /**
     *  Looks up OSID interfaces by OSID.
     *
     *  @return a list of OSID interfaces
     */

    public static java.util.Collection<OsidEnumeration> getEnumerations() {
        return (enumerations.values());
    }


    /**
     *  Adds an OSID enumeration.
     *
     *  @param enumeration an OSID enumeration
     */

    protected static void addEnumeration(OsidEnumeration enumeration) {
        enumerations.put(enumeration.getName(), enumeration);
        return;
    }
}
