package org.osid.meta.loader.course.program.batch;

import org.osid.meta.Osids;


/**
 *  Loads and stores the org.osid.course.program.batch OSID.
 *
 *  Generated by the Java Meta OSID Binder at Fri Jun 20 12:32:50 EDT 2014
 */

public class Loader {
    private static boolean loaded = false;
    private static boolean loadedCourseProgramBatchProfile = false;
    private static boolean loadedCourseProgramBatchManager = false;
    private static boolean loadedCourseProgramBatchProxyManager = false;
    private static boolean loadedProgramBatchAdminSession = false;
    private static boolean loadedProgramOfferingBatchAdminSession = false;
    private static boolean loadedCredentialBatchAdminSession = false;
    private static boolean loadedEnrollmentBatchAdminSession = false;
    private static boolean loadedProgramBatchForm = false;
    private static boolean loadedProgramBatchFormList = false;
    private static boolean loadedProgramOfferingPeer = false;
    private static boolean loadedProgramOfferingPeerList = false;
    private static boolean loadedProgramOfferingBatchForm = false;
    private static boolean loadedProgramOfferingBatchFormList = false;
    private static boolean loadedCredentialBatchForm = false;
    private static boolean loadedCredentialBatchFormList = false;
    private static boolean loadedEnrollmentPeer = false;
    private static boolean loadedEnrollmentPeerList = false;
    private static boolean loadedEnrollmentBatchForm = false;
    private static boolean loadedEnrollmentBatchFormList = false;

    public static void loadAllInterfaces() {
        if (loaded) {
            return;
        }

        loadCourseProgramBatchProfile();
        loadCourseProgramBatchManager();
        loadCourseProgramBatchProxyManager();
        loadProgramBatchAdminSession();
        loadProgramOfferingBatchAdminSession();
        loadCredentialBatchAdminSession();
        loadEnrollmentBatchAdminSession();
        loadProgramBatchForm();
        loadProgramBatchFormList();
        loadProgramOfferingPeer();
        loadProgramOfferingPeerList();
        loadProgramOfferingBatchForm();
        loadProgramOfferingBatchFormList();
        loadCredentialBatchForm();
        loadCredentialBatchFormList();
        loadEnrollmentPeer();
        loadEnrollmentPeerList();
        loadEnrollmentBatchForm();
        loadEnrollmentBatchFormList();
        loaded = true;
        loadedCourseProgramBatchProfile = true;
        loadedCourseProgramBatchManager = true;
        loadedCourseProgramBatchProxyManager = true;
        loadedProgramBatchAdminSession = true;
        loadedProgramOfferingBatchAdminSession = true;
        loadedCredentialBatchAdminSession = true;
        loadedEnrollmentBatchAdminSession = true;
        loadedProgramBatchForm = true;
        loadedProgramBatchFormList = true;
        loadedProgramOfferingPeer = true;
        loadedProgramOfferingPeerList = true;
        loadedProgramOfferingBatchForm = true;
        loadedProgramOfferingBatchFormList = true;
        loadedCredentialBatchForm = true;
        loadedCredentialBatchFormList = true;
        loadedEnrollmentPeer = true;
        loadedEnrollmentPeerList = true;
        loadedEnrollmentBatchForm = true;
        loadedEnrollmentBatchFormList = true;

        return;
    }


    public static void loadCourseProgramBatchProfile() {
        if (loadedCourseProgramBatchProfile) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.course.program.batch.CourseProgramBatchProfile");
        osids.getOsid("org.osid.course.program.batch").addInterface(iface);
        method = new OsidMethod("getProviderId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProvider");
        method.setReturn(new OsidReturn("org.osid.resource.Resource", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBrandingIds");
        method.setReturn(new OsidReturn("org.osid.id.IdList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranding");
        method.setReturn(new OsidReturn("org.osid.repository.AssetList", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLicense");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayName");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescription");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getVersion");
        method.setReturn(new OsidReturn("org.osid.installation.Version", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getReleaseDate");
        method.setReturn(new OsidReturn("org.osid.calendaring.DateTime", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsOSIDVersion");
        method.addParameter(new OsidParameter("version", "org.osid.installation.Version", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalRollback");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalBranching");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranchId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranch");
        method.setReturn(new OsidReturn("org.osid.journaling.Branch", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProxyRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsProxyRecordType");
        method.addParameter(new OsidParameter("proxyRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsVisibleFederation");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsProgramBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsProgramOfferingBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsCredentialBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsEnrollmentBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadCourseProgramBatchManager() {
        if (loadedCourseProgramBatchManager) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.course.program.batch.CourseProgramBatchManager");
        osids.getOsid("org.osid.course.program.batch").addInterface(iface);
        method = new OsidMethod("getProviderId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProvider");
        method.setReturn(new OsidReturn("org.osid.resource.Resource", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBrandingIds");
        method.setReturn(new OsidReturn("org.osid.id.IdList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranding");
        method.setReturn(new OsidReturn("org.osid.repository.AssetList", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLicense");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayName");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescription");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getVersion");
        method.setReturn(new OsidReturn("org.osid.installation.Version", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getReleaseDate");
        method.setReturn(new OsidReturn("org.osid.calendaring.DateTime", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsOSIDVersion");
        method.addParameter(new OsidParameter("version", "org.osid.installation.Version", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalRollback");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalBranching");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranchId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranch");
        method.setReturn(new OsidReturn("org.osid.journaling.Branch", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProxyRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsProxyRecordType");
        method.addParameter(new OsidParameter("proxyRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProviderId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProvider");
        method.setReturn(new OsidReturn("org.osid.resource.Resource", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBrandingIds");
        method.setReturn(new OsidReturn("org.osid.id.IdList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranding");
        method.setReturn(new OsidReturn("org.osid.repository.AssetList", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLicense");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayName");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescription");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getVersion");
        method.setReturn(new OsidReturn("org.osid.installation.Version", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getReleaseDate");
        method.setReturn(new OsidReturn("org.osid.calendaring.DateTime", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsOSIDVersion");
        method.addParameter(new OsidParameter("version", "org.osid.installation.Version", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalRollback");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalBranching");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranchId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranch");
        method.setReturn(new OsidReturn("org.osid.journaling.Branch", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProxyRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsProxyRecordType");
        method.addParameter(new OsidParameter("proxyRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("initialize");
        method.addParameter(new OsidParameter("runtime", "org.osid.OsidRuntimeManager", false));
        method.addError("org.osid.ConfigurationErrorException");
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("rollbackService");
        method.addParameter(new OsidParameter("rollbackTime", "java.util.Date", false, "timestamp"));
        method.setReturn(new OsidReturn("org.osid.journaling.JournalEntry", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("changeBranch");
        method.addParameter(new OsidParameter("branchId", "org.osid.id.Id", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsVisibleFederation");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsProgramBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsProgramOfferingBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsCredentialBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsEnrollmentBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProgramBatchAdminSession");
        method.setReturn(new OsidReturn("org.osid.course.program.batch.ProgramBatchAdminSession", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getProgramBatchAdminSessionForCourseCatalog");
        method.addParameter(new OsidParameter("courseCatalogId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.course.program.batch.ProgramBatchAdminSession", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getProgramOfferingBatchAdminSession");
        method.setReturn(new OsidReturn("org.osid.course.program.batch.ProgramOfferingBatchAdminSession", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getProgramOfferingBatchAdminSessionForCourseCatalog");
        method.addParameter(new OsidParameter("courseCatalogId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.course.program.batch.ProgramOfferingBatchAdminSession", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getCredentialBatchAdminSession");
        method.setReturn(new OsidReturn("org.osid.course.program.batch.CredentialBatchAdminSession", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getCredentialBatchAdminSessionForCourseCatalog");
        method.addParameter(new OsidParameter("courseCatalogId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.course.program.batch.CredentialBatchAdminSession", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getEnrollmentBatchAdminSession");
        method.setReturn(new OsidReturn("org.osid.course.program.batch.EnrollmentBatchAdminSession", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getEnrollmentBatchAdminSessionForCourseCatalog");
        method.addParameter(new OsidParameter("courseCatalogId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.course.program.batch.EnrollmentBatchAdminSession", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadCourseProgramBatchProxyManager() {
        if (loadedCourseProgramBatchProxyManager) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.course.program.batch.CourseProgramBatchProxyManager");
        osids.getOsid("org.osid.course.program.batch").addInterface(iface);
        method = new OsidMethod("getProviderId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProvider");
        method.setReturn(new OsidReturn("org.osid.resource.Resource", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBrandingIds");
        method.setReturn(new OsidReturn("org.osid.id.IdList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranding");
        method.setReturn(new OsidReturn("org.osid.repository.AssetList", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLicense");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayName");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescription");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getVersion");
        method.setReturn(new OsidReturn("org.osid.installation.Version", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getReleaseDate");
        method.setReturn(new OsidReturn("org.osid.calendaring.DateTime", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsOSIDVersion");
        method.addParameter(new OsidParameter("version", "org.osid.installation.Version", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalRollback");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalBranching");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranchId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranch");
        method.setReturn(new OsidReturn("org.osid.journaling.Branch", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProxyRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsProxyRecordType");
        method.addParameter(new OsidParameter("proxyRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProviderId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProvider");
        method.setReturn(new OsidReturn("org.osid.resource.Resource", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBrandingIds");
        method.setReturn(new OsidReturn("org.osid.id.IdList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranding");
        method.setReturn(new OsidReturn("org.osid.repository.AssetList", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLicense");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayName");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescription");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getVersion");
        method.setReturn(new OsidReturn("org.osid.installation.Version", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getReleaseDate");
        method.setReturn(new OsidReturn("org.osid.calendaring.DateTime", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsOSIDVersion");
        method.addParameter(new OsidParameter("version", "org.osid.installation.Version", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalRollback");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalBranching");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranchId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranch");
        method.setReturn(new OsidReturn("org.osid.journaling.Branch", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProxyRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsProxyRecordType");
        method.addParameter(new OsidParameter("proxyRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("initialize");
        method.addParameter(new OsidParameter("runtime", "org.osid.OsidRuntimeManager", false));
        method.addError("org.osid.ConfigurationErrorException");
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("rollbackService");
        method.addParameter(new OsidParameter("rollbackTime", "java.util.Date", false, "timestamp"));
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.journaling.JournalEntry", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("changeBranch");
        method.addParameter(new OsidParameter("branchId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsVisibleFederation");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsProgramBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsProgramOfferingBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsCredentialBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsEnrollmentBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProgramBatchAdminSession");
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.course.program.batch.ProgramBatchAdminSession", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getProgramBatchAdminSessionForCourseCatalog");
        method.addParameter(new OsidParameter("courseCatalogId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.course.program.batch.ProgramBatchAdminSession", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getProgramOfferingBatchAdminSession");
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.course.program.batch.ProgramOfferingBatchAdminSession", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getProgramOfferingBatchAdminSessionForCourseCatalog");
        method.addParameter(new OsidParameter("courseCatalogId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.course.program.batch.ProgramOfferingBatchAdminSession", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getCredentialBatchAdminSession");
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.course.program.batch.CredentialBatchAdminSession", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getCredentialBatchAdminSessionForCourseCatalog");
        method.addParameter(new OsidParameter("courseCatalogId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.course.program.batch.CredentialBatchAdminSession", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getEnrollmentBatchAdminSession");
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.course.program.batch.EnrollmentBatchAdminSession", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getEnrollmentBatchAdminSessionForCourseCatalog");
        method.addParameter(new OsidParameter("courseCatalogId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.course.program.batch.EnrollmentBatchAdminSession", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadProgramBatchAdminSession() {
        if (loadedProgramBatchAdminSession) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.course.program.batch.ProgramBatchAdminSession");
        osids.getOsid("org.osid.course.program.batch").addInterface(iface);
        method = new OsidMethod("getLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isAuthenticated");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDate");
        method.setReturn(new OsidReturn("java.util.Date", false, "timestamp"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getClockRate");
        method.setReturn(new OsidReturn("java.math.BigDecimal", false, "decimal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getFormatType");
        method.setReturn(new OsidReturn("org.osid.type.Type", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsTransactions");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("startTransaction");
        method.setReturn(new OsidReturn("org.osid.transaction.Transaction", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getCourseCatalogId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getCourseCatalog");
        method.setReturn(new OsidReturn("org.osid.course.CourseCatalog", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canCreatePrograms");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canCreateProgramWithRecordTypes");
        method.addParameter(new OsidParameter("programRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProgramFormForCreate");
        method.addParameter(new OsidParameter("programRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("org.osid.course.program.ProgramForm", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("createProgram");
        method.addParameter(new OsidParameter("programForm", "org.osid.course.program.ProgramForm", false));
        method.setReturn(new OsidReturn("org.osid.course.program.Program", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canUpdatePrograms");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProgramFormForUpdate");
        method.addParameter(new OsidParameter("programId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.course.program.ProgramForm", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("updateProgram");
        method.addParameter(new OsidParameter("programForm", "org.osid.course.program.ProgramForm", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canDeletePrograms");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteProgram");
        method.addParameter(new OsidParameter("programId", "org.osid.id.Id", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canManageProgramAliases");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("aliasProgram");
        method.addParameter(new OsidParameter("programId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("aliasId", "org.osid.id.Id", false));
        method.addError("org.osid.AlreadyExistsException");
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProgramFormsForCreate");
        method.addParameter(new OsidParameter("number", "long", false, "cardinal"));
        method.addParameter(new OsidParameter("programRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("org.osid.course.program.batch.ProgramBatchFormList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("createPrograms");
        method.addParameter(new OsidParameter("programForms", "org.osid.course.program.batch.ProgramBatchFormList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.CreateResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProgramFormsForUpdate");
        method.addParameter(new OsidParameter("programIds", "org.osid.id.IdList", false));
        method.setReturn(new OsidReturn("org.osid.course.program.batch.ProgramBatchFormList", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("updatePrograms");
        method.addParameter(new OsidParameter("programForms", "org.osid.course.program.batch.ProgramBatchFormList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.UpdateResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteAllPrograms");
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deletePrograms");
        method.addParameter(new OsidParameter("programIds", "org.osid.id.IdList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("aliasPrograms");
        method.addParameter(new OsidParameter("aliasRequests", "org.osid.transaction.batch.AliasRequestList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.AliasResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadProgramOfferingBatchAdminSession() {
        if (loadedProgramOfferingBatchAdminSession) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.course.program.batch.ProgramOfferingBatchAdminSession");
        osids.getOsid("org.osid.course.program.batch").addInterface(iface);
        method = new OsidMethod("getLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isAuthenticated");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDate");
        method.setReturn(new OsidReturn("java.util.Date", false, "timestamp"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getClockRate");
        method.setReturn(new OsidReturn("java.math.BigDecimal", false, "decimal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getFormatType");
        method.setReturn(new OsidReturn("org.osid.type.Type", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsTransactions");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("startTransaction");
        method.setReturn(new OsidReturn("org.osid.transaction.Transaction", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getCourseCatalogId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getCourseCatalog");
        method.setReturn(new OsidReturn("org.osid.course.CourseCatalog", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canCreatePrograms");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canCreateProgramWithRecordTypes");
        method.addParameter(new OsidParameter("programRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProgramFormForCreate");
        method.addParameter(new OsidParameter("programRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("org.osid.course.program.ProgramForm", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("createProgram");
        method.addParameter(new OsidParameter("programForm", "org.osid.course.program.ProgramForm", false));
        method.setReturn(new OsidReturn("org.osid.course.program.Program", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canUpdatePrograms");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProgramFormForUpdate");
        method.addParameter(new OsidParameter("programId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.course.program.ProgramForm", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("updateProgram");
        method.addParameter(new OsidParameter("programForm", "org.osid.course.program.ProgramForm", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canDeletePrograms");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteProgram");
        method.addParameter(new OsidParameter("programId", "org.osid.id.Id", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canManageProgramAliases");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("aliasProgram");
        method.addParameter(new OsidParameter("programId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("aliasId", "org.osid.id.Id", false));
        method.addError("org.osid.AlreadyExistsException");
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProgramOfferingFormsForCreate");
        method.addParameter(new OsidParameter("peers", "org.osid.course.program.batch.ProgramOfferingPeerList", false));
        method.addParameter(new OsidParameter("programOfferingRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("org.osid.course.program.batch.ProgramOfferingBatchFormList", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("createProgramOfferings");
        method.addParameter(new OsidParameter("programOfferingForms", "org.osid.course.program.batch.ProgramOfferingBatchFormList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.CreateResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProgramOfferingFormsForUpdate");
        method.addParameter(new OsidParameter("programOfferingIds", "org.osid.id.IdList", false));
        method.setReturn(new OsidReturn("org.osid.course.program.batch.ProgramOfferingBatchFormList", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("updateProgramOfferings");
        method.addParameter(new OsidParameter("programOfferingForms", "org.osid.course.program.batch.ProgramOfferingBatchFormList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.UpdateResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteAllProgramOfferings");
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteProgramOfferings");
        method.addParameter(new OsidParameter("programOfferingIds", "org.osid.id.IdList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteProgramOffeingsForProgram");
        method.addParameter(new OsidParameter("programId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteProgramOfferingsForTerm");
        method.addParameter(new OsidParameter("termId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("aliasProgramOfferings");
        method.addParameter(new OsidParameter("aliasRequests", "org.osid.transaction.batch.AliasRequestList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.AliasResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadCredentialBatchAdminSession() {
        if (loadedCredentialBatchAdminSession) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.course.program.batch.CredentialBatchAdminSession");
        osids.getOsid("org.osid.course.program.batch").addInterface(iface);
        method = new OsidMethod("getLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isAuthenticated");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDate");
        method.setReturn(new OsidReturn("java.util.Date", false, "timestamp"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getClockRate");
        method.setReturn(new OsidReturn("java.math.BigDecimal", false, "decimal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getFormatType");
        method.setReturn(new OsidReturn("org.osid.type.Type", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsTransactions");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("startTransaction");
        method.setReturn(new OsidReturn("org.osid.transaction.Transaction", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getCourseCatalogId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getCourseCatalog");
        method.setReturn(new OsidReturn("org.osid.course.CourseCatalog", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canCreateCredentials");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canCreateCredentialWithRecordTypes");
        method.addParameter(new OsidParameter("credentialRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getCredentialFormForCreate");
        method.addParameter(new OsidParameter("credentialRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("org.osid.course.program.CredentialForm", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("createCredential");
        method.addParameter(new OsidParameter("credentialForm", "org.osid.course.program.CredentialForm", false));
        method.setReturn(new OsidReturn("org.osid.course.program.Credential", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canUpdateCredentials");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getCredentialFormForUpdate");
        method.addParameter(new OsidParameter("credentialId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.course.program.CredentialForm", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("updateCredential");
        method.addParameter(new OsidParameter("credentialForm", "org.osid.course.program.CredentialForm", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canDeleteCredentials");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteCredential");
        method.addParameter(new OsidParameter("credentialId", "org.osid.id.Id", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canManageCredentialAliases");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("aliasCredential");
        method.addParameter(new OsidParameter("credentialId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("aliasId", "org.osid.id.Id", false));
        method.addError("org.osid.AlreadyExistsException");
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getCredentialFormsForCreate");
        method.addParameter(new OsidParameter("number", "long", false, "cardinal"));
        method.addParameter(new OsidParameter("credentialRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("org.osid.course.program.batch.CredentialBatchFormList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("createCredentials");
        method.addParameter(new OsidParameter("credentialForms", "org.osid.course.program.batch.CredentialBatchFormList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.CreateResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getCredentialFormsForUpdate");
        method.addParameter(new OsidParameter("credentialIds", "org.osid.id.IdList", false));
        method.setReturn(new OsidReturn("org.osid.course.program.batch.CredentialBatchFormList", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("updateCredentials");
        method.addParameter(new OsidParameter("credentialForms", "org.osid.course.program.batch.CredentialBatchFormList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.UpdateResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteAllCredentials");
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteCredentials");
        method.addParameter(new OsidParameter("credentialIds", "org.osid.id.IdList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("aliasCredentials");
        method.addParameter(new OsidParameter("aliasRequests", "org.osid.transaction.batch.AliasRequestList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.AliasResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadEnrollmentBatchAdminSession() {
        if (loadedEnrollmentBatchAdminSession) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.course.program.batch.EnrollmentBatchAdminSession");
        osids.getOsid("org.osid.course.program.batch").addInterface(iface);
        method = new OsidMethod("getLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isAuthenticated");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDate");
        method.setReturn(new OsidReturn("java.util.Date", false, "timestamp"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getClockRate");
        method.setReturn(new OsidReturn("java.math.BigDecimal", false, "decimal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getFormatType");
        method.setReturn(new OsidReturn("org.osid.type.Type", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsTransactions");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("startTransaction");
        method.setReturn(new OsidReturn("org.osid.transaction.Transaction", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getCourseCatalogId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getCourseCatalog");
        method.setReturn(new OsidReturn("org.osid.course.CourseCatalog", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canCreateEnrollments");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canCreateEnrollmentWithRecordTypes");
        method.addParameter(new OsidParameter("enrollmentRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEnrollmentFormForCreate");
        method.addParameter(new OsidParameter("programOfferingId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("resourceId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("enrollmentRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("org.osid.course.program.EnrollmentForm", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("createEnrollment");
        method.addParameter(new OsidParameter("enrollmentForm", "org.osid.course.program.EnrollmentForm", false));
        method.setReturn(new OsidReturn("org.osid.course.program.Enrollment", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canUpdateEnrollments");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEnrollmentFormForUpdate");
        method.addParameter(new OsidParameter("enrollmentId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.course.program.EnrollmentForm", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("updateEnrollment");
        method.addParameter(new OsidParameter("enrollmentForm", "org.osid.course.program.EnrollmentForm", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canDeleteEnrollments");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteEnrollment");
        method.addParameter(new OsidParameter("enrollmentId", "org.osid.id.Id", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canManageEnrollmentAliases");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("aliasEnrollment");
        method.addParameter(new OsidParameter("enrollmentId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("aliasId", "org.osid.id.Id", false));
        method.addError("org.osid.AlreadyExistsException");
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEnrollmentFormsForCreate");
        method.addParameter(new OsidParameter("peers", "org.osid.course.program.batch.EnrollmentPeerList", false));
        method.addParameter(new OsidParameter("enrollmentRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("org.osid.course.program.batch.EnrollmentBatchFormList", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("createEnrollments");
        method.addParameter(new OsidParameter("enrollmentForms", "org.osid.course.program.batch.EnrollmentBatchFormList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.CreateResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEnrollmentFormsForUpdate");
        method.addParameter(new OsidParameter("enrollmentIds", "org.osid.id.IdList", false));
        method.setReturn(new OsidReturn("org.osid.course.program.batch.EnrollmentBatchFormList", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("updateEnrollments");
        method.addParameter(new OsidParameter("enrollmentForms", "org.osid.course.program.batch.EnrollmentBatchFormList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.UpdateResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteAllEnrollments");
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteEnrollments");
        method.addParameter(new OsidParameter("enrollmentIds", "org.osid.id.IdList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteEnrollmentsForProgramOffering");
        method.addParameter(new OsidParameter("programOfferingId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteEnrollmentsForStudent");
        method.addParameter(new OsidParameter("resourceId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteIneffectiveEnrollmentsByDate");
        method.addParameter(new OsidParameter("date", "org.osid.calendaring.DateTime", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("aliasEnrollments");
        method.addParameter(new OsidParameter("aliasRequests", "org.osid.transaction.batch.AliasRequestList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.AliasResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadProgramBatchForm() {
        if (loadedProgramBatchForm) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.course.program.batch.ProgramBatchForm");
        osids.getOsid("org.osid.course.program.batch").addInterface(iface);
        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("hasRecordType");
        method.addParameter(new OsidParameter("recordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRequiredRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayNameMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setDisplayName");
        method.addParameter(new OsidParameter("displayName", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearDisplayName");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescriptionMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setDescription");
        method.addParameter(new OsidParameter("description", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearDescription");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getGenusTypeMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setGenusType");
        method.addParameter(new OsidParameter("genusType", "org.osid.type.Type", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearGenusType");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEnabledMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setEnabled");
        method.addParameter(new OsidParameter("enabled", "boolean", false, "boolean"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearEnabled");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisabledMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setDisabled");
        method.addParameter(new OsidParameter("disabled", "boolean", false, "boolean"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearDisabled");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getTitleMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setTitle");
        method.addParameter(new OsidParameter("title", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearTitle");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNumberMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setNumber");
        method.addParameter(new OsidParameter("number", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearNumber");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getSponsorsMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setSponsors");
        method.addParameter(new OsidParameter("resourceIds", "org.osid.id.Id[]", true));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearSponsors");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getCompletionRequirementsInfoMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setCompletionRequirementsInfo");
        method.addParameter(new OsidParameter("requirements", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearCompletionRequirementsInfo");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getCompletionRequirementsMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setCompletionRequirements");
        method.addParameter(new OsidParameter("requisiteIds", "org.osid.id.Id[]", true));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearCompletionRequirements");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getCredentialsMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setCredentials");
        method.addParameter(new OsidParameter("credentialIds", "org.osid.id.Id[]", true));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearCredentials");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProgramFormRecord");
        method.addParameter(new OsidParameter("programRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("org.osid.course.program.records.ProgramFormRecord", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProgramId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadProgramBatchFormList() {
        if (loadedProgramBatchFormList) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.course.program.batch.ProgramBatchFormList");
        osids.getOsid("org.osid.course.program.batch").addInterface(iface);
        method = new OsidMethod("hasNext");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("available");
        method.setReturn(new OsidReturn("long", false, "cardinal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("skip");
        method.addParameter(new OsidParameter("n", "long", false, "cardinal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNextProgramBatchForm");
        method.setReturn(new OsidReturn("org.osid.course.program.batch.ProgramBatchForm", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNextProgramBatchForms");
        method.addParameter(new OsidParameter("n", "long", false, "cardinal"));
        method.setReturn(new OsidReturn("org.osid.course.program.batch.ProgramBatchForm[]", true));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadProgramOfferingPeer() {
        if (loadedProgramOfferingPeer) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.course.program.batch.ProgramOfferingPeer");
        osids.getOsid("org.osid.course.program.batch").addInterface(iface);
        method = new OsidMethod("getProgramId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getTermId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadProgramOfferingPeerList() {
        if (loadedProgramOfferingPeerList) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.course.program.batch.ProgramOfferingPeerList");
        osids.getOsid("org.osid.course.program.batch").addInterface(iface);
        method = new OsidMethod("hasNext");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("available");
        method.setReturn(new OsidReturn("long", false, "cardinal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("skip");
        method.addParameter(new OsidParameter("n", "long", false, "cardinal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNextProgramOfferingPeer");
        method.setReturn(new OsidReturn("org.osid.course.program.batch.ProgramOfferingPeer", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNextProgramOfferingPeers");
        method.addParameter(new OsidParameter("n", "long", false, "cardinal"));
        method.setReturn(new OsidReturn("org.osid.course.program.batch.ProgramOfferingPeer[]", true));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadProgramOfferingBatchForm() {
        if (loadedProgramOfferingBatchForm) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.course.program.batch.ProgramOfferingBatchForm");
        osids.getOsid("org.osid.course.program.batch").addInterface(iface);
        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("hasRecordType");
        method.addParameter(new OsidParameter("recordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRequiredRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayNameMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setDisplayName");
        method.addParameter(new OsidParameter("displayName", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearDisplayName");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescriptionMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setDescription");
        method.addParameter(new OsidParameter("description", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearDescription");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getGenusTypeMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setGenusType");
        method.addParameter(new OsidParameter("genusType", "org.osid.type.Type", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearGenusType");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getStartDateMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setStartDate");
        method.addParameter(new OsidParameter("date", "org.osid.calendaring.DateTime", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearStartDate");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEndDateMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setEndDate");
        method.addParameter(new OsidParameter("date", "org.osid.calendaring.DateTime", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearEndDate");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getTitleMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setTitle");
        method.addParameter(new OsidParameter("title", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearTitle");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNumberMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setNumber");
        method.addParameter(new OsidParameter("number", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearNumber");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getSponsorsMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setSponsors");
        method.addParameter(new OsidParameter("sponsorIds", "org.osid.id.Id[]", true));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearSponsors");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getCompletionRequirementsInfoMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setCompletionRequirementsInfo");
        method.addParameter(new OsidParameter("requirements", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearCompletionRequirementsInfo");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getCompletionRequirementsMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setCompletionRequirements");
        method.addParameter(new OsidParameter("requisiteIds", "org.osid.id.Id[]", true));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearCompletionRequirements");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getCredentialsMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setCredentials");
        method.addParameter(new OsidParameter("credentialIds", "org.osid.id.Id[]", true));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearCredentials");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRequiresRegistrationMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setRequiresRegistration");
        method.addParameter(new OsidParameter("requiresRegistration", "boolean", false, "boolean"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearRequiresRegistration");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getMinimumSeatsMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setMinimumSeats");
        method.addParameter(new OsidParameter("seats", "long", false, "cardinal"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearMinimumSeats");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getMaximumSeatsMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setMaximumSeats");
        method.addParameter(new OsidParameter("seats", "long", false, "cardinal"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearMaximumSeats");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getURLMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setURL");
        method.addParameter(new OsidParameter("url", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearURL");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProgramOfferingFormRecord");
        method.addParameter(new OsidParameter("programOfferingRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("org.osid.course.program.records.ProgramOfferingFormRecord", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProgramId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getTermId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProgramOfferingId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadProgramOfferingBatchFormList() {
        if (loadedProgramOfferingBatchFormList) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.course.program.batch.ProgramOfferingBatchFormList");
        osids.getOsid("org.osid.course.program.batch").addInterface(iface);
        method = new OsidMethod("hasNext");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("available");
        method.setReturn(new OsidReturn("long", false, "cardinal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("skip");
        method.addParameter(new OsidParameter("n", "long", false, "cardinal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNextProgramOfferingBatchForm");
        method.setReturn(new OsidReturn("org.osid.course.program.batch.ProgramOfferingBatchForm", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNextProgramOfferingBatchForms");
        method.addParameter(new OsidParameter("n", "long", false, "cardinal"));
        method.setReturn(new OsidReturn("org.osid.course.program.batch.ProgramOfferingBatchForm[]", true));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadCredentialBatchForm() {
        if (loadedCredentialBatchForm) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.course.program.batch.CredentialBatchForm");
        osids.getOsid("org.osid.course.program.batch").addInterface(iface);
        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("hasRecordType");
        method.addParameter(new OsidParameter("recordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRequiredRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayNameMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setDisplayName");
        method.addParameter(new OsidParameter("displayName", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearDisplayName");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescriptionMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setDescription");
        method.addParameter(new OsidParameter("description", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearDescription");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getGenusTypeMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setGenusType");
        method.addParameter(new OsidParameter("genusType", "org.osid.type.Type", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearGenusType");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLifetimeMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLifetime");
        method.addParameter(new OsidParameter("lifetime", "org.osid.calendaring.Duration", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearLifetime");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getCredentialFormRecord");
        method.addParameter(new OsidParameter("credentialRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("org.osid.course.program.records.CredentialFormRecord", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getCredentialId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadCredentialBatchFormList() {
        if (loadedCredentialBatchFormList) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.course.program.batch.CredentialBatchFormList");
        osids.getOsid("org.osid.course.program.batch").addInterface(iface);
        method = new OsidMethod("hasNext");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("available");
        method.setReturn(new OsidReturn("long", false, "cardinal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("skip");
        method.addParameter(new OsidParameter("n", "long", false, "cardinal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNextCredentialBatchForm");
        method.setReturn(new OsidReturn("org.osid.course.program.batch.CredentialBatchForm", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNextCredentialBatchForms");
        method.addParameter(new OsidParameter("n", "long", false, "cardinal"));
        method.setReturn(new OsidReturn("org.osid.course.program.batch.CredentialBatchForm[]", true));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadEnrollmentPeer() {
        if (loadedEnrollmentPeer) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.course.program.batch.EnrollmentPeer");
        osids.getOsid("org.osid.course.program.batch").addInterface(iface);
        method = new OsidMethod("getProgramOfferingId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getStudentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadEnrollmentPeerList() {
        if (loadedEnrollmentPeerList) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.course.program.batch.EnrollmentPeerList");
        osids.getOsid("org.osid.course.program.batch").addInterface(iface);
        method = new OsidMethod("hasNext");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("available");
        method.setReturn(new OsidReturn("long", false, "cardinal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("skip");
        method.addParameter(new OsidParameter("n", "long", false, "cardinal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNextEnrollmentPeer");
        method.setReturn(new OsidReturn("org.osid.course.program.batch.EnrollmentPeer", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNextEnrollmentPeers");
        method.addParameter(new OsidParameter("n", "long", false, "cardinal"));
        method.setReturn(new OsidReturn("org.osid.course.program.batch.EnrollmentPeer[]", true));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadEnrollmentBatchForm() {
        if (loadedEnrollmentBatchForm) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.course.program.batch.EnrollmentBatchForm");
        osids.getOsid("org.osid.course.program.batch").addInterface(iface);
        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("hasRecordType");
        method.addParameter(new OsidParameter("recordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRequiredRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayNameMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setDisplayName");
        method.addParameter(new OsidParameter("displayName", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearDisplayName");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescriptionMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setDescription");
        method.addParameter(new OsidParameter("description", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearDescription");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getGenusTypeMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setGenusType");
        method.addParameter(new OsidParameter("genusType", "org.osid.type.Type", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearGenusType");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getStartDateMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setStartDate");
        method.addParameter(new OsidParameter("date", "org.osid.calendaring.DateTime", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearStartDate");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEndDateMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setEndDate");
        method.addParameter(new OsidParameter("date", "org.osid.calendaring.DateTime", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearEndDate");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEnrollmentFormRecord");
        method.addParameter(new OsidParameter("enrollmentRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("org.osid.course.program.records.EnrollmentFormRecord", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProgramOfferingId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getStudentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEnrollmentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadEnrollmentBatchFormList() {
        if (loadedEnrollmentBatchFormList) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.course.program.batch.EnrollmentBatchFormList");
        osids.getOsid("org.osid.course.program.batch").addInterface(iface);
        method = new OsidMethod("hasNext");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("available");
        method.setReturn(new OsidReturn("long", false, "cardinal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("skip");
        method.addParameter(new OsidParameter("n", "long", false, "cardinal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNextEnrollmentBatchForm");
        method.setReturn(new OsidReturn("org.osid.course.program.batch.EnrollmentBatchForm", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNextEnrollmentBatchForms");
        method.addParameter(new OsidParameter("n", "long", false, "cardinal"));
        method.setReturn(new OsidReturn("org.osid.course.program.batch.EnrollmentBatchForm[]", true));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }
}
