package org.osid.meta.loader.room.batch;

import org.osid.meta.Osids;


/**
 *  Loads and stores the org.osid.room.batch OSID.
 *
 *  Generated by the Java Meta OSID Binder at Fri Jun 20 12:33:04 EDT 2014
 */

public class Loader {
    private static boolean loaded = false;
    private static boolean loadedRoomBatchProfile = false;
    private static boolean loadedRoomBatchManager = false;
    private static boolean loadedRoomBatchProxyManager = false;
    private static boolean loadedRoomBatchAdminSession = false;
    private static boolean loadedFloorBatchAdminSession = false;
    private static boolean loadedBuildingBatchAdminSession = false;
    private static boolean loadedCampusBatchAdminSession = false;
    private static boolean loadedRoomBatchForm = false;
    private static boolean loadedRoomBatchFormList = false;
    private static boolean loadedFloorBatchForm = false;
    private static boolean loadedFloorBatchFormList = false;
    private static boolean loadedBuildingBatchForm = false;
    private static boolean loadedBuildingBatchFormList = false;
    private static boolean loadedCampusBatchForm = false;
    private static boolean loadedCampusBatchFormList = false;

    public static void loadAllInterfaces() {
        if (loaded) {
            return;
        }

        loadRoomBatchProfile();
        loadRoomBatchManager();
        loadRoomBatchProxyManager();
        loadRoomBatchAdminSession();
        loadFloorBatchAdminSession();
        loadBuildingBatchAdminSession();
        loadCampusBatchAdminSession();
        loadRoomBatchForm();
        loadRoomBatchFormList();
        loadFloorBatchForm();
        loadFloorBatchFormList();
        loadBuildingBatchForm();
        loadBuildingBatchFormList();
        loadCampusBatchForm();
        loadCampusBatchFormList();
        loaded = true;
        loadedRoomBatchProfile = true;
        loadedRoomBatchManager = true;
        loadedRoomBatchProxyManager = true;
        loadedRoomBatchAdminSession = true;
        loadedFloorBatchAdminSession = true;
        loadedBuildingBatchAdminSession = true;
        loadedCampusBatchAdminSession = true;
        loadedRoomBatchForm = true;
        loadedRoomBatchFormList = true;
        loadedFloorBatchForm = true;
        loadedFloorBatchFormList = true;
        loadedBuildingBatchForm = true;
        loadedBuildingBatchFormList = true;
        loadedCampusBatchForm = true;
        loadedCampusBatchFormList = true;

        return;
    }


    public static void loadRoomBatchProfile() {
        if (loadedRoomBatchProfile) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.room.batch.RoomBatchProfile");
        osids.getOsid("org.osid.room.batch").addInterface(iface);
        method = new OsidMethod("getProviderId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProvider");
        method.setReturn(new OsidReturn("org.osid.resource.Resource", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBrandingIds");
        method.setReturn(new OsidReturn("org.osid.id.IdList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranding");
        method.setReturn(new OsidReturn("org.osid.repository.AssetList", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLicense");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayName");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescription");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getVersion");
        method.setReturn(new OsidReturn("org.osid.installation.Version", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getReleaseDate");
        method.setReturn(new OsidReturn("org.osid.calendaring.DateTime", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsOSIDVersion");
        method.addParameter(new OsidParameter("version", "org.osid.installation.Version", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalRollback");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalBranching");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranchId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranch");
        method.setReturn(new OsidReturn("org.osid.journaling.Branch", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProxyRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsProxyRecordType");
        method.addParameter(new OsidParameter("proxyRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsVisibleFederation");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsRoomBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsFloorBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsBuildingBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsCampusBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadRoomBatchManager() {
        if (loadedRoomBatchManager) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.room.batch.RoomBatchManager");
        osids.getOsid("org.osid.room.batch").addInterface(iface);
        method = new OsidMethod("getProviderId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProvider");
        method.setReturn(new OsidReturn("org.osid.resource.Resource", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBrandingIds");
        method.setReturn(new OsidReturn("org.osid.id.IdList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranding");
        method.setReturn(new OsidReturn("org.osid.repository.AssetList", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLicense");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayName");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescription");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getVersion");
        method.setReturn(new OsidReturn("org.osid.installation.Version", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getReleaseDate");
        method.setReturn(new OsidReturn("org.osid.calendaring.DateTime", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsOSIDVersion");
        method.addParameter(new OsidParameter("version", "org.osid.installation.Version", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalRollback");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalBranching");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranchId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranch");
        method.setReturn(new OsidReturn("org.osid.journaling.Branch", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProxyRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsProxyRecordType");
        method.addParameter(new OsidParameter("proxyRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProviderId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProvider");
        method.setReturn(new OsidReturn("org.osid.resource.Resource", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBrandingIds");
        method.setReturn(new OsidReturn("org.osid.id.IdList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranding");
        method.setReturn(new OsidReturn("org.osid.repository.AssetList", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLicense");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayName");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescription");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getVersion");
        method.setReturn(new OsidReturn("org.osid.installation.Version", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getReleaseDate");
        method.setReturn(new OsidReturn("org.osid.calendaring.DateTime", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsOSIDVersion");
        method.addParameter(new OsidParameter("version", "org.osid.installation.Version", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalRollback");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalBranching");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranchId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranch");
        method.setReturn(new OsidReturn("org.osid.journaling.Branch", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProxyRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsProxyRecordType");
        method.addParameter(new OsidParameter("proxyRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("initialize");
        method.addParameter(new OsidParameter("runtime", "org.osid.OsidRuntimeManager", false));
        method.addError("org.osid.ConfigurationErrorException");
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("rollbackService");
        method.addParameter(new OsidParameter("rollbackTime", "java.util.Date", false, "timestamp"));
        method.setReturn(new OsidReturn("org.osid.journaling.JournalEntry", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("changeBranch");
        method.addParameter(new OsidParameter("branchId", "org.osid.id.Id", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsVisibleFederation");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsRoomBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsFloorBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsBuildingBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsCampusBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRoomBatchAdminSession");
        method.setReturn(new OsidReturn("org.osid.room.batch.RoomBatchAdminSession", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getRoomBatchAdminSessionForCampus");
        method.addParameter(new OsidParameter("campusId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.room.batch.RoomBatchAdminSession", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getFloorBatchAdminSession");
        method.setReturn(new OsidReturn("org.osid.room.batch.FloorBatchAdminSession", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getFloorBatchAdminSessionForCampus");
        method.addParameter(new OsidParameter("campusId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.room.batch.FloorBatchAdminSession", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getBuildingBatchAdminSession");
        method.setReturn(new OsidReturn("org.osid.room.batch.BuildingBatchAdminSession", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getBuildingBatchAdminSessionForCampus");
        method.addParameter(new OsidParameter("campusId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.room.batch.BuildingBatchAdminSession", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getCampusBatchAdminSession");
        method.setReturn(new OsidReturn("org.osid.room.batch.CampusBatchAdminSession", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadRoomBatchProxyManager() {
        if (loadedRoomBatchProxyManager) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.room.batch.RoomBatchProxyManager");
        osids.getOsid("org.osid.room.batch").addInterface(iface);
        method = new OsidMethod("getProviderId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProvider");
        method.setReturn(new OsidReturn("org.osid.resource.Resource", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBrandingIds");
        method.setReturn(new OsidReturn("org.osid.id.IdList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranding");
        method.setReturn(new OsidReturn("org.osid.repository.AssetList", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLicense");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayName");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescription");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getVersion");
        method.setReturn(new OsidReturn("org.osid.installation.Version", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getReleaseDate");
        method.setReturn(new OsidReturn("org.osid.calendaring.DateTime", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsOSIDVersion");
        method.addParameter(new OsidParameter("version", "org.osid.installation.Version", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalRollback");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalBranching");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranchId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranch");
        method.setReturn(new OsidReturn("org.osid.journaling.Branch", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProxyRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsProxyRecordType");
        method.addParameter(new OsidParameter("proxyRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProviderId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProvider");
        method.setReturn(new OsidReturn("org.osid.resource.Resource", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBrandingIds");
        method.setReturn(new OsidReturn("org.osid.id.IdList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranding");
        method.setReturn(new OsidReturn("org.osid.repository.AssetList", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLicense");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayName");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescription");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getVersion");
        method.setReturn(new OsidReturn("org.osid.installation.Version", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getReleaseDate");
        method.setReturn(new OsidReturn("org.osid.calendaring.DateTime", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsOSIDVersion");
        method.addParameter(new OsidParameter("version", "org.osid.installation.Version", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalRollback");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalBranching");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranchId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranch");
        method.setReturn(new OsidReturn("org.osid.journaling.Branch", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProxyRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsProxyRecordType");
        method.addParameter(new OsidParameter("proxyRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("initialize");
        method.addParameter(new OsidParameter("runtime", "org.osid.OsidRuntimeManager", false));
        method.addError("org.osid.ConfigurationErrorException");
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("rollbackService");
        method.addParameter(new OsidParameter("rollbackTime", "java.util.Date", false, "timestamp"));
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.journaling.JournalEntry", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("changeBranch");
        method.addParameter(new OsidParameter("branchId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsVisibleFederation");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsRoomBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsFloorBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsBuildingBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsCampusBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRoomBatchAdminSession");
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.room.batch.RoomBatchAdminSession", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getRoomBatchAdminSessionForCampus");
        method.addParameter(new OsidParameter("campusId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.room.batch.RoomBatchAdminSession", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getFloorBatchAdminSession");
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.room.batch.FloorBatchAdminSession", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getFloorBatchAdminSessionForCampus");
        method.addParameter(new OsidParameter("campusId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.room.batch.FloorBatchAdminSession", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getBuildingBatchAdminSession");
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.room.batch.BuildingBatchAdminSession", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getBuildingBatchAdminSessionForCampus");
        method.addParameter(new OsidParameter("campusId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.room.batch.BuildingBatchAdminSession", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getCampusBatchAdminSession");
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.room.batch.CampusBatchAdminSession", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadRoomBatchAdminSession() {
        if (loadedRoomBatchAdminSession) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.room.batch.RoomBatchAdminSession");
        osids.getOsid("org.osid.room.batch").addInterface(iface);
        method = new OsidMethod("getLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isAuthenticated");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDate");
        method.setReturn(new OsidReturn("java.util.Date", false, "timestamp"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getClockRate");
        method.setReturn(new OsidReturn("java.math.BigDecimal", false, "decimal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getFormatType");
        method.setReturn(new OsidReturn("org.osid.type.Type", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsTransactions");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("startTransaction");
        method.setReturn(new OsidReturn("org.osid.transaction.Transaction", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getCampusId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getCampus");
        method.setReturn(new OsidReturn("org.osid.room.Campus", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canCreateRooms");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canCreateRoomWithRecordTypes");
        method.addParameter(new OsidParameter("roomRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRoomFormForCreate");
        method.addParameter(new OsidParameter("floorId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("roomRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("org.osid.room.RoomForm", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("createRoom");
        method.addParameter(new OsidParameter("roomForm", "org.osid.room.RoomForm", false));
        method.setReturn(new OsidReturn("org.osid.room.Room", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canUpdateRooms");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRoomFormForUpdate");
        method.addParameter(new OsidParameter("roomId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.room.RoomForm", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("updateRoom");
        method.addParameter(new OsidParameter("roomForm", "org.osid.room.RoomForm", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canDeleteRooms");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteRoom");
        method.addParameter(new OsidParameter("roomId", "org.osid.id.Id", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canManageRoomAliases");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("aliasRoom");
        method.addParameter(new OsidParameter("roomId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("aliasId", "org.osid.id.Id", false));
        method.addError("org.osid.AlreadyExistsException");
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRoomFormsForCreate");
        method.addParameter(new OsidParameter("floorIds", "org.osid.id.IdList", false));
        method.addParameter(new OsidParameter("roomRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("org.osid.room.batch.RoomBatchFormList", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("createRooms");
        method.addParameter(new OsidParameter("roomForms", "org.osid.room.batch.RoomBatchFormList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.CreateResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRoomFormsForUpdate");
        method.addParameter(new OsidParameter("roomIds", "org.osid.id.IdList", false));
        method.setReturn(new OsidReturn("org.osid.room.batch.RoomBatchFormList", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("updateRooms");
        method.addParameter(new OsidParameter("roomForms", "org.osid.room.batch.RoomBatchFormList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.UpdateResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteAllRooms");
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteRooms");
        method.addParameter(new OsidParameter("roomIds", "org.osid.id.IdList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteRoomsForFloor");
        method.addParameter(new OsidParameter("roomId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteIneffectiveRoomsByDate");
        method.addParameter(new OsidParameter("date", "org.osid.calendaring.DateTime", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("aliasRooms");
        method.addParameter(new OsidParameter("aliasRequests", "org.osid.transaction.batch.AliasRequestList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.AliasResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadFloorBatchAdminSession() {
        if (loadedFloorBatchAdminSession) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.room.batch.FloorBatchAdminSession");
        osids.getOsid("org.osid.room.batch").addInterface(iface);
        method = new OsidMethod("getLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isAuthenticated");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDate");
        method.setReturn(new OsidReturn("java.util.Date", false, "timestamp"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getClockRate");
        method.setReturn(new OsidReturn("java.math.BigDecimal", false, "decimal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getFormatType");
        method.setReturn(new OsidReturn("org.osid.type.Type", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsTransactions");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("startTransaction");
        method.setReturn(new OsidReturn("org.osid.transaction.Transaction", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getCampusId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getCampus");
        method.setReturn(new OsidReturn("org.osid.room.Campus", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canCreateFloors");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canCreateFloorWithRecordTypes");
        method.addParameter(new OsidParameter("floorRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getFloorFormForCreate");
        method.addParameter(new OsidParameter("buildingId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("floorRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("org.osid.room.FloorForm", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("createFloor");
        method.addParameter(new OsidParameter("floorForm", "org.osid.room.FloorForm", false));
        method.setReturn(new OsidReturn("org.osid.room.Floor", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canUpdateFloors");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getFloorFormForUpdate");
        method.addParameter(new OsidParameter("floorId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.room.FloorForm", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("updateFloor");
        method.addParameter(new OsidParameter("floorForm", "org.osid.room.FloorForm", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canDeleteFloors");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteFloor");
        method.addParameter(new OsidParameter("floorId", "org.osid.id.Id", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canManageFloorAliases");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("aliasFloor");
        method.addParameter(new OsidParameter("floorId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("aliasId", "org.osid.id.Id", false));
        method.addError("org.osid.AlreadyExistsException");
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getFloorFormsForCreate");
        method.addParameter(new OsidParameter("buildingIds", "org.osid.id.IdList", false));
        method.addParameter(new OsidParameter("floorRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("org.osid.room.batch.FloorBatchFormList", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("createFloors");
        method.addParameter(new OsidParameter("floorForms", "org.osid.room.batch.FloorBatchFormList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.CreateResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getFloorFormsForUpdate");
        method.addParameter(new OsidParameter("floorIds", "org.osid.id.IdList", false));
        method.setReturn(new OsidReturn("org.osid.room.batch.FloorBatchFormList", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("updateFloors");
        method.addParameter(new OsidParameter("floorForms", "org.osid.room.batch.FloorBatchFormList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.UpdateResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteAllFloors");
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteFloors");
        method.addParameter(new OsidParameter("floorIds", "org.osid.id.IdList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteFloorsForBuilding");
        method.addParameter(new OsidParameter("buildingId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteIneffectiveFloorsByDate");
        method.addParameter(new OsidParameter("date", "org.osid.calendaring.DateTime", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("aliasFloors");
        method.addParameter(new OsidParameter("aliasRequests", "org.osid.transaction.batch.AliasRequestList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.AliasResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadBuildingBatchAdminSession() {
        if (loadedBuildingBatchAdminSession) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.room.batch.BuildingBatchAdminSession");
        osids.getOsid("org.osid.room.batch").addInterface(iface);
        method = new OsidMethod("getLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isAuthenticated");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDate");
        method.setReturn(new OsidReturn("java.util.Date", false, "timestamp"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getClockRate");
        method.setReturn(new OsidReturn("java.math.BigDecimal", false, "decimal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getFormatType");
        method.setReturn(new OsidReturn("org.osid.type.Type", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsTransactions");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("startTransaction");
        method.setReturn(new OsidReturn("org.osid.transaction.Transaction", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getCampusId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getCampus");
        method.setReturn(new OsidReturn("org.osid.room.Campus", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canCreateBuildings");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canCreateBuildingWithRecordTypes");
        method.addParameter(new OsidParameter("buildingRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBuildingFormForCreate");
        method.addParameter(new OsidParameter("buildingRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("org.osid.room.BuildingForm", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("createBuilding");
        method.addParameter(new OsidParameter("buildingForm", "org.osid.room.BuildingForm", false));
        method.setReturn(new OsidReturn("org.osid.room.Building", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canUpdateBuildings");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBuildingFormForUpdate");
        method.addParameter(new OsidParameter("buildingId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.room.BuildingForm", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("updateBuilding");
        method.addParameter(new OsidParameter("buildingForm", "org.osid.room.BuildingForm", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canDeleteBuildings");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteBuilding");
        method.addParameter(new OsidParameter("buildingId", "org.osid.id.Id", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canManageBuildingAliases");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("aliasBuilding");
        method.addParameter(new OsidParameter("buildingId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("aliasId", "org.osid.id.Id", false));
        method.addError("org.osid.AlreadyExistsException");
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBuildingFormsForCreate");
        method.addParameter(new OsidParameter("number", "long", false, "cardinal"));
        method.addParameter(new OsidParameter("buildingRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("org.osid.room.batch.BuildingBatchFormList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("createBuildings");
        method.addParameter(new OsidParameter("buildingForms", "org.osid.room.batch.BuildingBatchFormList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.CreateResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBuildingFormsForUpdate");
        method.addParameter(new OsidParameter("buildingIds", "org.osid.id.IdList", false));
        method.setReturn(new OsidReturn("org.osid.room.batch.BuildingBatchFormList", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("updateBuildings");
        method.addParameter(new OsidParameter("buildingForms", "org.osid.room.batch.BuildingBatchFormList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.UpdateResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteAllBuildings");
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteBuildings");
        method.addParameter(new OsidParameter("buildingIds", "org.osid.id.IdList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteIneffectiveBuildingsByDate");
        method.addParameter(new OsidParameter("date", "org.osid.calendaring.DateTime", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("aliasBuildings");
        method.addParameter(new OsidParameter("aliasRequests", "org.osid.transaction.batch.AliasRequestList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.AliasResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadCampusBatchAdminSession() {
        if (loadedCampusBatchAdminSession) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.room.batch.CampusBatchAdminSession");
        osids.getOsid("org.osid.room.batch").addInterface(iface);
        method = new OsidMethod("getLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isAuthenticated");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDate");
        method.setReturn(new OsidReturn("java.util.Date", false, "timestamp"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getClockRate");
        method.setReturn(new OsidReturn("java.math.BigDecimal", false, "decimal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getFormatType");
        method.setReturn(new OsidReturn("org.osid.type.Type", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsTransactions");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("startTransaction");
        method.setReturn(new OsidReturn("org.osid.transaction.Transaction", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("canCreateCampuses");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canCreateCampusWithRecordTypes");
        method.addParameter(new OsidParameter("campusRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getCampusFormForCreate");
        method.addParameter(new OsidParameter("campusRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("org.osid.room.CampusForm", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("createCampus");
        method.addParameter(new OsidParameter("campusForm", "org.osid.room.CampusForm", false));
        method.setReturn(new OsidReturn("org.osid.room.Campus", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canUpdateCampuses");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getCampusFormForUpdate");
        method.addParameter(new OsidParameter("campusId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.room.CampusForm", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("updateCampus");
        method.addParameter(new OsidParameter("campusForm", "org.osid.room.CampusForm", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canDeleteCampuses");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteCampus");
        method.addParameter(new OsidParameter("campusId", "org.osid.id.Id", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canManageCampusAliases");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("aliasCampus");
        method.addParameter(new OsidParameter("campusId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("aliasId", "org.osid.id.Id", false));
        method.addError("org.osid.AlreadyExistsException");
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getCampusFormsForCreate");
        method.addParameter(new OsidParameter("number", "long", false, "cardinal"));
        method.addParameter(new OsidParameter("campusRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("org.osid.room.batch.CampusBatchFormList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("createCampuses");
        method.addParameter(new OsidParameter("campusForms", "org.osid.room.batch.CampusBatchFormList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.CreateResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getCampusFormsForUpdate");
        method.addParameter(new OsidParameter("campusIds", "org.osid.id.IdList", false));
        method.setReturn(new OsidReturn("org.osid.room.batch.CampusBatchFormList", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("updateCampuses");
        method.addParameter(new OsidParameter("campusForms", "org.osid.room.batch.CampusBatchFormList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.UpdateResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteAllCampuses");
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteCampuses");
        method.addParameter(new OsidParameter("campusIds", "org.osid.id.IdList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("aliasCampuses");
        method.addParameter(new OsidParameter("aliasRequests", "org.osid.transaction.batch.AliasRequestList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.AliasResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadRoomBatchForm() {
        if (loadedRoomBatchForm) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.room.batch.RoomBatchForm");
        osids.getOsid("org.osid.room.batch").addInterface(iface);
        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("hasRecordType");
        method.addParameter(new OsidParameter("recordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRequiredRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayNameMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setDisplayName");
        method.addParameter(new OsidParameter("displayName", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearDisplayName");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescriptionMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setDescription");
        method.addParameter(new OsidParameter("description", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearDescription");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getGenusTypeMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setGenusType");
        method.addParameter(new OsidParameter("genusType", "org.osid.type.Type", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearGenusType");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getStartDateMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setStartDate");
        method.addParameter(new OsidParameter("date", "org.osid.calendaring.DateTime", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearStartDate");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEndDateMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setEndDate");
        method.addParameter(new OsidParameter("date", "org.osid.calendaring.DateTime", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearEndDate");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEnclosingRoomMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setEnclosingRoom");
        method.addParameter(new OsidParameter("roomId", "org.osid.id.Id", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearEnclosingRoom");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDesignatedNameMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setDesignatedName");
        method.addParameter(new OsidParameter("name", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearDesignatedName");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getCodeMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setCode");
        method.addParameter(new OsidParameter("code", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearCode");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAreaMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setArea");
        method.addParameter(new OsidParameter("area", "java.math.BigDecimal", false, "decimal"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearArea");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getOccupancyLimitMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setOccupancyLimit");
        method.addParameter(new OsidParameter("linit", "long", false, "cardinal"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearOccupancyLimit");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getResourcesMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setResources");
        method.addParameter(new OsidParameter("resourceIds", "org.osid.id.IdList", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearResources");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRoomFormRecord");
        method.addParameter(new OsidParameter("roomRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("org.osid.room.records.RoomFormRecord", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getFloorId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRoomId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadRoomBatchFormList() {
        if (loadedRoomBatchFormList) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.room.batch.RoomBatchFormList");
        osids.getOsid("org.osid.room.batch").addInterface(iface);
        method = new OsidMethod("hasNext");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("available");
        method.setReturn(new OsidReturn("long", false, "cardinal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("skip");
        method.addParameter(new OsidParameter("n", "long", false, "cardinal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNextRoomBatchForm");
        method.setReturn(new OsidReturn("org.osid.room.batch.RoomBatchForm", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNextRoomBatchForms");
        method.addParameter(new OsidParameter("n", "long", false, "cardinal"));
        method.setReturn(new OsidReturn("org.osid.room.batch.RoomBatchForm[]", true));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadFloorBatchForm() {
        if (loadedFloorBatchForm) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.room.batch.FloorBatchForm");
        osids.getOsid("org.osid.room.batch").addInterface(iface);
        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("hasRecordType");
        method.addParameter(new OsidParameter("recordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRequiredRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayNameMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setDisplayName");
        method.addParameter(new OsidParameter("displayName", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearDisplayName");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescriptionMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setDescription");
        method.addParameter(new OsidParameter("description", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearDescription");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getGenusTypeMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setGenusType");
        method.addParameter(new OsidParameter("genusType", "org.osid.type.Type", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearGenusType");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getStartDateMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setStartDate");
        method.addParameter(new OsidParameter("date", "org.osid.calendaring.DateTime", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearStartDate");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEndDateMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setEndDate");
        method.addParameter(new OsidParameter("date", "org.osid.calendaring.DateTime", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearEndDate");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNumberMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setNumber");
        method.addParameter(new OsidParameter("number", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearNumber");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getGrossAreaMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setGrossArea");
        method.addParameter(new OsidParameter("area", "java.math.BigDecimal", false, "decimal"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearGrossArea");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getFloorFormRecord");
        method.addParameter(new OsidParameter("floorRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("org.osid.room.records.FloorFormRecord", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBuildingId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getFloorId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadFloorBatchFormList() {
        if (loadedFloorBatchFormList) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.room.batch.FloorBatchFormList");
        osids.getOsid("org.osid.room.batch").addInterface(iface);
        method = new OsidMethod("hasNext");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("available");
        method.setReturn(new OsidReturn("long", false, "cardinal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("skip");
        method.addParameter(new OsidParameter("n", "long", false, "cardinal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNextFloorBatchForm");
        method.setReturn(new OsidReturn("org.osid.room.batch.FloorBatchForm", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNextFloorBatchForms");
        method.addParameter(new OsidParameter("n", "long", false, "cardinal"));
        method.setReturn(new OsidReturn("org.osid.room.batch.FloorBatchForm[]", true));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadBuildingBatchForm() {
        if (loadedBuildingBatchForm) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.room.batch.BuildingBatchForm");
        osids.getOsid("org.osid.room.batch").addInterface(iface);
        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("hasRecordType");
        method.addParameter(new OsidParameter("recordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRequiredRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayNameMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setDisplayName");
        method.addParameter(new OsidParameter("displayName", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearDisplayName");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescriptionMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setDescription");
        method.addParameter(new OsidParameter("description", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearDescription");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getGenusTypeMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setGenusType");
        method.addParameter(new OsidParameter("genusType", "org.osid.type.Type", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearGenusType");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getStartDateMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setStartDate");
        method.addParameter(new OsidParameter("date", "org.osid.calendaring.DateTime", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearStartDate");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEndDateMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setEndDate");
        method.addParameter(new OsidParameter("date", "org.osid.calendaring.DateTime", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearEndDate");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAddressMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setAddress");
        method.addParameter(new OsidParameter("addressId", "org.osid.id.Id", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearAddress");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getOfficialNameMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setOfficialName");
        method.addParameter(new OsidParameter("name", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearOfficialName");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNumberMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setNumber");
        method.addParameter(new OsidParameter("number", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearNumber");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEnclosingBuildingMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setEnclosingBuilding");
        method.addParameter(new OsidParameter("buildingId", "org.osid.id.Id", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearEnclosingBuilding");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getGrossAreaMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setGrossArea");
        method.addParameter(new OsidParameter("area", "java.math.BigDecimal", false, "decimal"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearGrossArea");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBuildingFormRecord");
        method.addParameter(new OsidParameter("buildingRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("org.osid.room.records.BuildingFormRecord", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBuildingId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadBuildingBatchFormList() {
        if (loadedBuildingBatchFormList) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.room.batch.BuildingBatchFormList");
        osids.getOsid("org.osid.room.batch").addInterface(iface);
        method = new OsidMethod("hasNext");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("available");
        method.setReturn(new OsidReturn("long", false, "cardinal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("skip");
        method.addParameter(new OsidParameter("n", "long", false, "cardinal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNextBuildingBatchForm");
        method.setReturn(new OsidReturn("org.osid.room.batch.BuildingBatchForm", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNextBuildingBatchForms");
        method.addParameter(new OsidParameter("n", "long", false, "cardinal"));
        method.setReturn(new OsidReturn("org.osid.room.batch.BuildingBatchForm[]", true));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadCampusBatchForm() {
        if (loadedCampusBatchForm) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.room.batch.CampusBatchForm");
        osids.getOsid("org.osid.room.batch").addInterface(iface);
        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("hasRecordType");
        method.addParameter(new OsidParameter("recordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRequiredRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayNameMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setDisplayName");
        method.addParameter(new OsidParameter("displayName", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearDisplayName");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescriptionMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setDescription");
        method.addParameter(new OsidParameter("description", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearDescription");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getGenusTypeMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setGenusType");
        method.addParameter(new OsidParameter("genusType", "org.osid.type.Type", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearGenusType");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProviderMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setProvider");
        method.addParameter(new OsidParameter("providerId", "org.osid.id.Id", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearProvider");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBrandingMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setBranding");
        method.addParameter(new OsidParameter("assetIds", "org.osid.id.Id[]", true));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearBranding");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLicenseMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLicense");
        method.addParameter(new OsidParameter("license", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearLicense");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getCampusFormRecord");
        method.addParameter(new OsidParameter("campusRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("org.osid.room.records.CampusFormRecord", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getCampusId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getParentsMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setParents");
        method.addParameter(new OsidParameter("parents", "org.osid.id.Id[]", true));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearParents");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadCampusBatchFormList() {
        if (loadedCampusBatchFormList) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.room.batch.CampusBatchFormList");
        osids.getOsid("org.osid.room.batch").addInterface(iface);
        method = new OsidMethod("hasNext");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("available");
        method.setReturn(new OsidReturn("long", false, "cardinal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("skip");
        method.addParameter(new OsidParameter("n", "long", false, "cardinal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNextCampusBatchForm");
        method.setReturn(new OsidReturn("org.osid.room.batch.CampusBatchForm", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNextCampusBatchForms");
        method.addParameter(new OsidParameter("n", "long", false, "cardinal"));
        method.setReturn(new OsidReturn("org.osid.room.batch.CampusBatchForm[]", true));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }
}
