/**
 * <p>The Open Service Interface Definitions for the org.osid.metering
 * service.</p>
 * 
 * <p>The Metering OSID is an auxiliary service to read measurements and 
 * calculate statistics. </p> 
 * <h4> Meters </h4> 
 * 
 * <p> The <code> Meter </code> represents a measure. Examples might be the 
 * number of access times or the number of bytes consumed. The <code> Meter 
 * </code> itself is simply the identifier for the measure. The count for a 
 * specific reference <code> Id </code> at the current point in time is 
 * available in a <code> Reading </code> of a <code> Meter </code> using the 
 * <code> MeterReadingSession. </code> </p> 
 * <h4> Statistics </h4> 
 * 
 * <p> <code> Statistics </code> are <code> Readings </code> over a period of 
 * time. <code> Statistics </code> offer sums, averages, and other statistical 
 * data for a <code> Meter </code> in a given period of time. </p> 
 * <h4> Cataloging </h4> 
 * 
 * <p> <code> Meters </code> can be organized into <code> Utility </code> 
 * catalogs for organization and federation. </p> 
 * <h4> Sub Packages </h4> 
 * 
 * <p> The Metering OSID contains a Metering Batch OSID for managing <code> 
 * Meters </code> in bulk and a Metering Threshold OSID for managing and 
 * subscribing to thresholds. </p>
 * 
 * <br/><hr/><br/>
 * 
 * <p>Copyright &copy; 2009-2011 Ingenescus. All Rights Reserved. </p>
 * 
 * <p>This Work is being provided by the copyright holder(s) subject to the 
 * following license. By obtaining, using and/or copying this Work, you agree 
 * that you have read, understand, and will comply with the following terms 
 * and conditions. </p> 
 * 
 * <p> Permission to use, copy and distribute unmodified versions of this 
 * Work, for any purpose, without fee or royalty is hereby granted, provided 
 * that you include the above copyright notices and the terms of this license 
 * on ALL copies of the Work or portions thereof. </p> 
 * 
 * <p> You may nodify or create Derivatives of this Work only for your 
 * internal purposes. You shall not distribute or transfer any such Derivative 
 * of this Work to any location or to any third party. For the purposes of 
 * this license, "Derivative" shall mean any derivative of the Work as defined 
 * in the United States Copyright Act of 1976, such as a translation or 
 * modification. </p> 
 * 
 * <p> This Work and the information contained herein is provided on an "AS 
 * IS" basis WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT 
 * NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN 
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
 * CONNECTION WITH THE WORK OR THE USE OR OTHER DEALINGS IN THE WORK. </p> 
 * 
 * <p> The export of software employing encryption technology may require a 
 * specific license from the United States Government. It is the 
 * responsibility of any person or organization contemplating export to obtain 
 * such a license before exporting this Work. </p>
 */

package org.osid.metering;
