/**
 * <p>The Open Service Interface Definitions for the org.osid.offering.rules
 * service.</p>
 * 
 * <p>The Offering Rules OSID includes rules services to manage rules and 
 * constraints applied to <code> CanonicalUnits. </code> </p> 
 * <h4> CanonicalUnitEnabler Rule </h4> 
 * 
 * <p> A <code> CanonicalUnitEnabler </code> governs the operation of 
 * canonical units. Active canonical units can be offered and disabled 
 * canonical units cannot be offered. </p> 
 * <h4> CanonicalUnitProcessor Rule </h4> 
 * 
 * <p> An <code> CanonicalUnitProcessorRule </code> is an <code> OsidRule 
 * </code> that manages the offerings of <code> CanonicalUnits. </code> </p> 
 * <h4> OfferingConstrainer Rule </h4> 
 * 
 * <p> An <code> OfferingConstrainer </code> is an OsidRule that manages 
 * constraints on the <code> Offering </code> by the <code> CanonicalUnit. 
 * </code> </p> 
 * <h4> OfferingConstrainerEnabler Rule </h4> 
 * 
 * <p> An <code> OfferingConstrainerEnabler </code> is an <code> OsidRule 
 * </code> that operates the enabling and disabling of an <code> 
 * OfferingConstrainer </code> through management of the <code> CanonicalUnit 
 * </code> effective dates. An <code> OfferingConstrainerEnabler </code> may 
 * modify the effective dates of an <code> CanonicalUnit </code> to make them 
 * effective at a fture time or expire them. An <code> 
 * OfferingConstrainerEnabler </code> that resurrects an expired <code> 
 * OfferingConstrainer </code> may create a new <code> OfferingConstrainer 
 * </code> with new effective dates to preserve the audit trail of effective 
 * <code> OfferingConstrainers. </code> </p> 
 * <h4> CanonicalUnitProcessorEnabler Rule </h4> 
 * 
 * <p> An <code> CanonicalUnitProcessorEnabler </code> is an <code> OsidRule 
 * </code> that operates the enabling and disabling of an <code> 
 * CanonicalUnitProcessor </code> through management of the <code> 
 * CanonicalUnitProcessor </code> effective dates. An <code> 
 * CanonicalUnitProcessorEnabler </code> may modify the effective dates of an 
 * <code> CanonicalUnitProcessor </code> to make them effective at a fture 
 * time or expire them. An <code> CanonicalUnitProcessorEnabler </code> that 
 * resurrects an expired <code> CanonicalUnit </code> may create a new <code> 
 * CanonicalUnitProcessor </code> with new effective dates to preserve the 
 * audit trail of effective <code> CanonicalUnitProcessors. </code> </p> 
 * <h4> Catalogue Cataloging </h4> 
 * 
 * <p> <code> OfferingConstrainers, </code> <code> 
 * OfferingConstrainerEnablers, </code> <code> CanonicalUnitProcessors, 
 * </code> and <code> CanonicalUnitProcessorEnablers </code> are also 
 * cataloged in <code> Catalogues. </code> </p>
 * 
 * <br/><hr/><br/>
 * 
 * <p>Copyright &copy; 2013 Ingenescus. All Rights Reserved. </p>
 * 
 * <p>This Work is being provided by the copyright holder(s) subject to the 
 * following license. By obtaining, using and/or copying this Work, you agree 
 * that you have read, understand, and will comply with the following terms 
 * and conditions. </p> 
 * 
 * <p> Permission to use, copy and distribute unmodified versions of this 
 * Work, for any purpose, without fee or royalty is hereby granted, provided 
 * that you include the above copyright notices and the terms of this license 
 * on ALL copies of the Work or portions thereof. </p> 
 * 
 * <p> You may nodify or create Derivatives of this Work only for your 
 * internal purposes. You shall not distribute or transfer any such Derivative 
 * of this Work to any location or to any third party. For the purposes of 
 * this license, "Derivative" shall mean any derivative of the Work as defined 
 * in the United States Copyright Act of 1976, such as a translation or 
 * modification. </p> 
 * 
 * <p> This Work and the information contained herein is provided on an "AS 
 * IS" basis WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT 
 * NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN 
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
 * CONNECTION WITH THE WORK OR THE USE OR OTHER DEALINGS IN THE WORK. </p> 
 * 
 * <p> The export of software employing encryption technology may require a 
 * specific license from the United States Government. It is the 
 * responsibility of any person or organization contemplating export to obtain 
 * such a license before exporting this Work. </p>
 */

package org.osid.offering.rules;
