/**
 * <p>The Open Service Interface Definitions for the org.osid.ordering
 * service.</p>
 * 
 * <p>The Ordering OSID provides a means to manage orders and product 
 * catalogs. </p> 
 * <h4> Orders </h4> 
 * 
 * <p> <code> Orders </code> are a set of items submitted to an ordering 
 * system as a transaction. Each <code> Order </code> submitted by an agent on 
 * behalf of a customer. An <code> Order </code> is composed of a set of 
 * Items. Each <code> Item </code> includes a <code> Product, </code> 
 * quantity, and line item cost. </p> 
 * <h4> Products </h4> 
 * 
 * <p> A <code> Product </code> represents anything that can be ordered. A 
 * <code> Product </code> may have a fixed availability and includes <code> 
 * PriceSchedules. </code> </p> 
 * <h4> Prices and Price Schedules </h4> 
 * 
 * <p> A <code> PriceSchedule </code> is a list of <code> Prices </code> that 
 * can be applied to <code> Products. </code> A <code> Price </code> is an 
 * <code> OsidRule </code> that determines a cost based on some basic pricing 
 * rules such as quantity ranges and demographics. </p> 
 * <h4> Store Cataloging </h4> 
 * 
 * <p> <code> Orders, </code> <code> Products, </code> and <code> 
 * PriceSchedules </code> can be organized into federateable <code> Stores. 
 * </code> </p> 
 * <h4> Sub Packages </h4> 
 * 
 * <p> The Ordering OSID includes an Ordering Rules OSID for managing the 
 * effectiveness of <code> Prices. </code> The Ordering OSID also contains an 
 * Ordering Batch OSID for managing <code> Prices, </code> <code> Orders, 
 * </code> and <code> Products </code> in buk. </p>
 * 
 * <br/><hr/><br/>
 * 
 * <p>Copyright &copy; 2010 Ingenescus. All Rights Reserved. </p>
 * 
 * <p>This Work is being provided by the copyright holder(s) subject to the 
 * following license. By obtaining, using and/or copying this Work, you agree 
 * that you have read, understand, and will comply with the following terms 
 * and conditions. </p> 
 * 
 * <p> Permission to use, copy and distribute unmodified versions of this 
 * Work, for any purpose, without fee or royalty is hereby granted, provided 
 * that you include the above copyright notices and the terms of this license 
 * on ALL copies of the Work or portions thereof. </p> 
 * 
 * <p> You may nodify or create Derivatives of this Work only for your 
 * internal purposes. You shall not distribute or transfer any such Derivative 
 * of this Work to any location or to any third party. For the purposes of 
 * this license, "Derivative" shall mean any derivative of the Work as defined 
 * in the United States Copyright Act of 1976, such as a translation or 
 * modification. </p> 
 * 
 * <p> This Work and the information contained herein is provided on an "AS 
 * IS" basis WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT 
 * NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN 
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
 * CONNECTION WITH THE WORK OR THE USE OR OTHER DEALINGS IN THE WORK. </p> 
 * 
 * <p> The export of software employing encryption technology may require a 
 * specific license from the United States Government. It is the 
 * responsibility of any person or organization contemplating export to obtain 
 * such a license before exporting this Work. </p>
 */

package org.osid.ordering;
