/**
 * <p>The Open Service Interface Definitions for the org.osid.provisioning.rules
 * service.</p>
 * 
 * <p>The Provisioning Rules OSID includes rules services to manage rules for 
 * the Provisioning OSID. </p> 
 * <h4> QueueConstrainer Rule </h4> 
 * 
 * <p> A <code> QueueConstrainer </code> is an <code> OsidRule </code> that 
 * manages constraints upon provisioning requests that may enter a <code> 
 * Queue </code> . </p> 
 * <h4> QueueConstrainerEnabler Rule </h4> 
 * 
 * <p> A <code> QueueConstrainerEnabler </code> is an <code> OsidRule </code> 
 * that operates the enabling and disabling of a <code> QueueConstrainer 
 * </code> . </p> 
 * <h4> QueueProcessor Rule </h4> 
 * 
 * <p> A <code> QueueProcessorRule </code> is an <code> OsidRule </code> that 
 * manages the processing of provisioning requests in a <code> Queue </code> . 
 * </p> 
 * <h4> QueueProcessorEnabler Rule </h4> 
 * 
 * <p> A <code> QueueProcessorEnabler </code> is an <code> OsidRule </code> 
 * that operates the enabling and disabling of a <code> QueueProcessor </code> 
 * . </p> 
 * <h4> PoolConstrainer Rule </h4> 
 * 
 * <p> An <code> PoolConstrainer </code> is an <code> OsidRule </code> that 
 * manages the constraints on resources that may be in a <code> Pool </code> . 
 * </p> 
 * <h4> PoolConstrainerEnabler Rule </h4> 
 * 
 * <p> An <code> PoolConstrainerEnabler </code> is an <code> OsidRule </code> 
 * that operates the enabling and disabling of an <code> PoolConstrainer. 
 * </code> </p> 
 * <h4> PoolProcessor Rule </h4> 
 * 
 * <p> An <code> PoolProcessorRule </code> is an <code> OsidRule </code> that 
 * manages the allocation of resources out of a <code> Pool </code> . </p> 
 * <h4> PoolProcessorEnabler Rule </h4> 
 * 
 * <p> An <code> PoolProcessorEnabler </code> is an <code> OsidRule </code> 
 * that operates the enabling and disabling of an <code> PoolProcessor </code> 
 * . </p> 
 * <h4> BrokerConstrainer Rule </h4> 
 * 
 * <p> An <code> BrokerConstrainer </code> is an <code> OsidRule </code> that 
 * manages provisioning constraints on <code> Pools </code> and <code> Queues 
 * </code> in a <code> Broker </code> . </p> 
 * <h4> BrokerConstrainerEnabler Rule </h4> 
 * 
 * <p> An <code> BrokerConstrainerEnabler </code> is an <code> OsidRule 
 * </code> that operates the enabling and disabling of an <code> 
 * BrokerConstrainer </code> . </p> 
 * <h4> BrokerProcessor Rule </h4> 
 * 
 * <p> An <code> BrokerProcessorRule </code> is an <code> OsidRule </code> 
 * that manages the operations of a <code> Broker </code> . </p> 
 * <h4> BrokerProcessorEnabler Rule </h4> 
 * 
 * <p> An <code> BrokerProcessorEnabler </code> is an <code> OsidRule </code> 
 * that operates the enabling and disabling of an <code> BrokerProcessor 
 * </code> . </p> 
 * <h4> Distributor Cataloging </h4> 
 * 
 * <p> <code> QueueConstrainers, </code> <code> QueueConstrainerEnablers, 
 * </code> <code> QueueProcessors, </code> <code> QueueProcessorEnablers, 
 * </code> <code> PoolConstrainers, </code> <code> PoolConstrainerEnablers, 
 * </code> <code> PoolProcessors, </code> <code> PoolProcessorEnablers, 
 * </code> <code> BrokerConstrainers, </code> <code> 
 * BrokerConstrainerEnablers, </code> <code> BrokerProcessors, </code> and 
 * <code> BrokerProcessorEnablers </code> are also cataloged in <code> 
 * Distributors. </code> </p>
 * 
 * <br/><hr/><br/>
 * 
 * <p>Copyright &copy; 2011 Ingenescus. All Rights Reserved. </p>
 * 
 * <p>This Work is being provided by the copyright holder(s) subject to the 
 * following license. By obtaining, using and/or copying this Work, you agree 
 * that you have read, understand, and will comply with the following terms 
 * and conditions. </p> 
 * 
 * <p> Permission to use, copy and distribute unmodified versions of this 
 * Work, for any purpose, without fee or royalty is hereby granted, provided 
 * that you include the above copyright notices and the terms of this license 
 * on ALL copies of the Work or portions thereof. </p> 
 * 
 * <p> You may nodify or create Derivatives of this Work only for your 
 * internal purposes. You shall not distribute or transfer any such Derivative 
 * of this Work to any location or to any third party. For the purposes of 
 * this license, "Derivative" shall mean any derivative of the Work as defined 
 * in the United States Copyright Act of 1976, such as a translation or 
 * modification. </p> 
 * 
 * <p> This Work and the information contained herein is provided on an "AS 
 * IS" basis WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT 
 * NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN 
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
 * CONNECTION WITH THE WORK OR THE USE OR OTHER DEALINGS IN THE WORK. </p> 
 * 
 * <p> The export of software employing encryption technology may require a 
 * specific license from the United States Government. It is the 
 * responsibility of any person or organization contemplating export to obtain 
 * such a license before exporting this Work. </p>
 */

package org.osid.provisioning.rules;
