/**
 * <p>The Open Service Interface Definitions for the org.osid.recipe
 * service.</p>
 * 
 * <p>The Recipe OSID is the how-to service providing a means for managing 
 * lists of directions to create or do something. The Recipe OSID can be used 
 * in conjunction with the Resourcing OSID and the Tracking OSID to provide 
 * instructions or stock answers on accomplishing a variety of tasks. The 
 * Recipe OSID may also be used alongside the Learning OSID for managing the 
 * skills required to complete various tasks and it may be used in conjunction 
 * with the Inventory OSID for managing an inventory of materials required to 
 * accomplish jobs. While the Recipe OSID may also be used with the Checklist 
 * OSID for a simplified tracking of progress, it can always be used to store 
 * your favorite recipes. </p> 
 * <h4> Recipe </h4> 
 * 
 * <p> A <code> Recipe </code> is an <code> OsidObject </code> which 
 * represents a set of <code> Directions </code> to achieve some goal. </p> 
 * <h4> Direction </h4> 
 * 
 * <p> A <code> Direction </code> is an instruction or a process step. A 
 * <code> Direction </code> may have some <code> Assets </code> to illustrate 
 * the instruction. </p> 
 * 
 * <p> <code> Directions </code> may be further broken down into <code> 
 * Procedures </code> and include a specified list of materials or ingredients 
 * for accomplishing the step. </p> 
 * <h4> Procedure </h4> 
 * 
 * <p> <code> Procedures </code> can be used to specifically describe an 
 * action that needs to be executed within a <code> Direction. </code> 
 * Normalization of procedures allow for the linking to learning <code> 
 * Objectives </code> to describe the skill or knowledge necessary for 
 * accomplishing the task. </p> 
 * <h4> Ingredient </h4> 
 * 
 * <p> An <code> Ingredient </code> is a quantity of some group of items, or 
 * inventory <code> Stock, </code> managed in the Inventory OSID. The units of 
 * a quantity are expressed as a <code> Type </code> such as "units," 
 * "pounds," or "cups." </p> 
 * <h4> Cookbook Cataloging </h4> 
 * 
 * <p> <code> Recipes, </code> <code> Directions, and </code> <code> 
 * Procedures </code> are organized into federatable <code> OsidCatalogs 
 * </code> called <code> Cookbooks. </code> </p>
 * 
 * <br/><hr/><br/>
 * 
 * <p>Copyright &copy; 2010 Ingenescus. All Rights Reserved. </p>
 * 
 * <p>This Work is being provided by the copyright holder(s) subject to the 
 * following license. By obtaining, using and/or copying this Work, you agree 
 * that you have read, understand, and will comply with the following terms 
 * and conditions. </p> 
 * 
 * <p> Permission to use, copy and distribute unmodified versions of this 
 * Work, for any purpose, without fee or royalty is hereby granted, provided 
 * that you include the above copyright notices and the terms of this license 
 * on ALL copies of the Work or portions thereof. </p> 
 * 
 * <p> You may nodify or create Derivatives of this Work only for your 
 * internal purposes. You shall not distribute or transfer any such Derivative 
 * of this Work to any location or to any third party. For the purposes of 
 * this license, "Derivative" shall mean any derivative of the Work as defined 
 * in the United States Copyright Act of 1976, such as a translation or 
 * modification. </p> 
 * 
 * <p> This Work and the information contained herein is provided on an "AS 
 * IS" basis WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT 
 * NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN 
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
 * CONNECTION WITH THE WORK OR THE USE OR OTHER DEALINGS IN THE WORK. </p> 
 * 
 * <p> The export of software employing encryption technology may require a 
 * specific license from the United States Government. It is the 
 * responsibility of any person or organization contemplating export to obtain 
 * such a license before exporting this Work. </p>
 */

package org.osid.recipe;
