/**
 * <p>The Open Service Interface Definitions for the org.osid.recognition
 * service.</p>
 * 
 * <p>The Recognition OSID is a service that confers <code> Awards </code> on 
 * to <code> Resources. </code> The Recognition OSID may be orchestrated with 
 * the Voting OSID for managing nominees. </p> 
 * <h4> Awards </h4> 
 * 
 * <p> An <code> Award </code> is an <code> OsidObject </code> representing 
 * something conferred on to recipient <code> Resources. </code> </p> 
 * <h4> Conferrals </h4> 
 * 
 * <p> A <code> Conferral </code> is an <code> OsidRelationship </code> 
 * describing an <code> Award </code> given to one or more recipient <code> 
 * Resources. </code> </p> 
 * 
 * <p> The award may be for something such as a body of work represnting by an 
 * external <code> OsidObject </code> . </p> 
 * <h4> Convocations </h4> 
 * 
 * <p> A <code> Convocation </code> represents an issuing of <code> Conferrals 
 * </code> for a managed set of <code> Awards. </code> <code> Convocations 
 * </code> also serve to relate the <code> Conferrals </code> to a <code> 
 * TimePeriod </code> . </p> 
 * <h4> Academy Cataloging </h4> 
 * 
 * <p> <code> Awards, Conferrals, </code> and <code> Convocations </code> can 
 * be organized into federateable <code> Academy </code> catalogs. </p>
 * 
 * <br/><hr/><br/>
 * 
 * <p>Copyright &copy; 2010 Ingenescus. All Rights Reserved. </p>
 * 
 * <p>This Work is being provided by the copyright holder(s) subject to the 
 * following license. By obtaining, using and/or copying this Work, you agree 
 * that you have read, understand, and will comply with the following terms 
 * and conditions. </p> 
 * 
 * <p> Permission to use, copy and distribute unmodified versions of this 
 * Work, for any purpose, without fee or royalty is hereby granted, provided 
 * that you include the above copyright notices and the terms of this license 
 * on ALL copies of the Work or portions thereof. </p> 
 * 
 * <p> You may nodify or create Derivatives of this Work only for your 
 * internal purposes. You shall not distribute or transfer any such Derivative 
 * of this Work to any location or to any third party. For the purposes of 
 * this license, "Derivative" shall mean any derivative of the Work as defined 
 * in the United States Copyright Act of 1976, such as a translation or 
 * modification. </p> 
 * 
 * <p> This Work and the information contained herein is provided on an "AS 
 * IS" basis WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT 
 * NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN 
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
 * CONNECTION WITH THE WORK OR THE USE OR OTHER DEALINGS IN THE WORK. </p> 
 * 
 * <p> The export of software employing encryption technology may require a 
 * specific license from the United States Government. It is the 
 * responsibility of any person or organization contemplating export to obtain 
 * such a license before exporting this Work. </p>
 */

package org.osid.recognition;
