/**
 * <p>The Open Service Interface Definitions for the org.osid.relationship
 * service.</p>
 * 
 * <p>The Relationship OSID provides the ability to relate and manage data 
 * between <code> OsidObjects. </code> </p> 
 * <h4> Relationships </h4> 
 * 
 * <p> The Relationship OSID defines a <code> Relationship </code> that can be 
 * used to explicitly identify a relationship between two OSID <code> Ids 
 * </code> and manage information specific to the relationship. </p> 
 * 
 * <p> The Relationship OSID is a building block on which relationships 
 * defined in the context of other OSIDs can be built. Examples of 
 * relationships include the enrollment record of a student in a <code> Course 
 * </code> or the commitment or a person to an <code> Event. </code> </p> 
 * 
 * <p> The Relationship OSID depends on the relationship Type to indicate the 
 * nature of the relationship including its natural ordering between the 
 * source and destination <code> Ids. </code> A relationship of type "friend" 
 * may place the peers in either order and be queryable in either order. A 
 * relationship of type "parent" is between a father peer and a son peer, but 
 * not the other way around. Queries of the son peer based on the "parent" 
 * type is not equiavelent to queries of the father peer based on the "parent" 
 * type. </p> 
 * 
 * <p> Such directional relationships may be accompanied by two types. An 
 * additional relationship type of "child" can be used with the son peer to 
 * determine the father peer. The directionality and the inverse among the 
 * types are part of the type definition. </p> 
 * <h4> Family Cataloging </h4> 
 * 
 * <p> <code> Relationships </code> may be cataloged using the <code> Family 
 * </code> interface. </p> 
 * <h4> Sub Packages </h4> 
 * 
 * <p> The Relationship OSID includes a Relationship Rules OSID for 
 * controlling the enable status of <code> Relationships. </code> </p>
 * 
 * <br/><hr/><br/>
 * 
 * <p>Copyright &copy; 2010 Ingenescus. All Rights Reserved. </p>
 * 
 * <p>This Work is being provided by the copyright holder(s) subject to the 
 * following license. By obtaining, using and/or copying this Work, you agree 
 * that you have read, understand, and will comply with the following terms 
 * and conditions. </p> 
 * 
 * <p> Permission to use, copy and distribute unmodified versions of this 
 * Work, for any purpose, without fee or royalty is hereby granted, provided 
 * that you include the above copyright notices and the terms of this license 
 * on ALL copies of the Work or portions thereof. </p> 
 * 
 * <p> You may nodify or create Derivatives of this Work only for your 
 * internal purposes. You shall not distribute or transfer any such Derivative 
 * of this Work to any location or to any third party. For the purposes of 
 * this license, "Derivative" shall mean any derivative of the Work as defined 
 * in the United States Copyright Act of 1976, such as a translation or 
 * modification. </p> 
 * 
 * <p> This Work and the information contained herein is provided on an "AS 
 * IS" basis WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT 
 * NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN 
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
 * CONNECTION WITH THE WORK OR THE USE OR OTHER DEALINGS IN THE WORK. </p> 
 * 
 * <p> The export of software employing encryption technology may require a 
 * specific license from the United States Government. It is the 
 * responsibility of any person or organization contemplating export to obtain 
 * such a license before exporting this Work. </p>
 */

package org.osid.relationship;
