/**
 * <p>The Open Service Interface Definitions for the org.osid.room
 * service.</p>
 * 
 * <p>The Room OSID provides a service for space accounting. </p> 
 * <h4> Rooms </h4> 
 * 
 * <p> A <code> Room </code> is an identifiable space on a Floor. A room genus 
 * Type may indicate the primary type of a <code> Room, </code> such as a 
 * classroom, an office, or a condo. <code> Rooms </code> may have 
 * subdivisions, as in the Gran Ballrrom may be partitioned into Ballroom-A 
 * and Ballroom-B. </p> 
 * 
 * <p> <code> Rooms </code> may also have fixed <code> Resources </code> such 
 * as projectors and refridgerators. These <code> Resources </code> represent 
 * classes of equipment of interest when searching for rooms. Specific 
 * inventory management can be performed in the Inventory OSID. </p> 
 * <h4> Floors </h4> 
 * 
 * <p> A <code> Floor </code> contains a set of <code> Rooms </code> within a 
 * Building. </p> 
 * <h4> Buildings </h4> 
 * 
 * <p> <code> Buildings </code> have an <code> Address </code> and may be 
 * subdivided into smaller buildings. For example, Building 14 includes 
 * buildings 14E and 14N. </p> 
 * <h4> Contact Orchestration </h4> 
 * 
 * <p> <code> Room, </code> <code> Floors, </code> or <code> Buildings </code> 
 * may have contact information for a variety of purposes including ownership, 
 * scheduling, and maintenance. These contact relationships can be performed 
 * by orchestrating the Contact OSID. </p> 
 * <h4> Mapping & Resources </h4> 
 * 
 * <p> The Room OSID provides more detailed management the space accounting 
 * than what is capable from the more abtrsact Resource or Mapping OSIDs. 
 * <code> Rooms, </code> <code> Floors </code> or <code> Buildings </code> in 
 * the Room OSID may appear by way of <code> Resources </code> or <code> 
 * Locations </code> in other OSIDs. </p> 
 * 
 * <p> In addition to defining abstract <code> Locations, </code> the Mapping 
 * OSID manages geospatial information of <code> Locations </code> using 
 * <code> Coordinate </code> and SpatialUnits. To manage geospatial 
 * information with respect to the Room OSID, the Mapping OSID can be 
 * orchestrated by mapping <code> Rooms, </code> <code> Floors, </code> and 
 * <code> Buildings </code> to <code> Locations. </code> </p> 
 * <h4> Campus Cataloging </h4> 
 * 
 * <p> <code> Rooms, Floors, </code> and <code> Buildings </code> may be 
 * organized into federateable <code> OsidCatalogs </code> of <code> Campuses. 
 * </code> </p> 
 * <h4> Sub Packages </h4> 
 * 
 * <p> The Room OSID includes a Room Squatting OSID for relating owners or 
 * users of rooms, a Room Construction OSID for tracking construction of and 
 * within buildings. and a Room Batch OSID for performing bulk operations. 
 * </p>
 * 
 * <br/><hr/><br/>
 * 
 * <p>Copyright &copy; 2011 Ingenescus. All Rights Reserved. </p>
 * 
 * <p>This Work is being provided by the copyright holder(s) subject to the 
 * following license. By obtaining, using and/or copying this Work, you agree 
 * that you have read, understand, and will comply with the following terms 
 * and conditions. </p> 
 * 
 * <p> Permission to use, copy and distribute unmodified versions of this 
 * Work, for any purpose, without fee or royalty is hereby granted, provided 
 * that you include the above copyright notices and the terms of this license 
 * on ALL copies of the Work or portions thereof. </p> 
 * 
 * <p> You may modify or create Derivatives of this Work only for your 
 * internal purposes. You shall not distribute or transfer any such Derivative 
 * of this Work to any location or to any third party. For the purposes of 
 * this license, "Derivative" shall mean any derivative of the Work as defined 
 * in the United States Copyright Act of 1976, such as a translation or 
 * modification. </p> 
 * 
 * <p> This Work and the information contained herein is provided on an "AS 
 * IS" basis WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT 
 * NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN 
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
 * CONNECTION WITH THE WORK OR THE USE OR OTHER DEALINGS IN THE WORK. </p> 
 * 
 * <p> The export of software employing encryption technology may require a 
 * specific license from the United States Government. It is the 
 * responsibility of any person or organization contemplating export to obtain 
 * such a license before exporting this Work. </p>
 */

package org.osid.room;
