/**
 * <p>The Open Service Interface Definitions for the org.osid.workflow.rules
 * service.</p>
 * 
 * <p>The Workflow Rules OSID includes rules services to manage rules for the 
 * Workflow OSID. </p> 
 * <h4> StepConstrainer Rule </h4> 
 * 
 * <p> A <code> StepConstrainer </code> is an <code> OsidRule </code> that 
 * manages constraints upon <code> Work </code> in a <code> Step </code> . 
 * </p> 
 * <h4> StepConstrainerEnabler Rule </h4> 
 * 
 * <p> A <code> StepConstrainerEnabler </code> is an <code> OsidRule </code> 
 * that operates the enabling and disabling of a <code> StepConstrainer 
 * </code> . </p> 
 * <h4> StepProcessor Rule </h4> 
 * 
 * <p> A <code> StepProcessorRule </code> is an <code> OsidRule </code> that 
 * manages the processing of <code> Work </code> in a <code> Step </code> . 
 * </p> 
 * <h4> StepProcessorEnabler Rule </h4> 
 * 
 * <p> A <code> StepProcessorEnabler </code> is an <code> OsidRule </code> 
 * that operates the enabling and disabling of a <code> StepProcessor </code> 
 * . </p> 
 * <h4> ProcessEnabler Rule </h4> 
 * 
 * <p> An <code> ProcessEnabler </code> is an <code> OsidRule </code> that 
 * manages the acive and inactive status of a <code> Process </code> . </p> 
 * <h4> Office Cataloging </h4> 
 * 
 * <p> <code> StepConstrainers, </code> <code> StepConstrainerEnablers, 
 * </code> <code> StepProcessors, </code> <code> StepProcessorEnablers, 
 * </code> <code> ProcessEnablers, </code> <code> ProcessEnablerEnablers 
 * </code> are also cataloged in <code> Office. </code> </p>
 * 
 * <br/><hr/><br/>
 * 
 * <p>Copyright &copy; 2011 Ingenescus. All Rights Reserved. </p>
 * 
 * <p>This Work is being provided by the copyright holder(s) subject to the 
 * following license. By obtaining, using and/or copying this Work, you agree 
 * that you have read, understand, and will comply with the following terms 
 * and conditions. </p> 
 * 
 * <p> Permission to use, copy and distribute unmodified versions of this 
 * Work, for any purpose, without fee or royalty is hereby granted, provided 
 * that you include the above copyright notices and the terms of this license 
 * on ALL copies of the Work or portions thereof. </p> 
 * 
 * <p> You may nodify or create Derivatives of this Work only for your 
 * internal purposes. You shall not distribute or transfer any such Derivative 
 * of this Work to any location or to any third party. For the purposes of 
 * this license, "Derivative" shall mean any derivative of the Work as defined 
 * in the United States Copyright Act of 1976, such as a translation or 
 * modification. </p> 
 * 
 * <p> This Work and the information contained herein is provided on an "AS 
 * IS" basis WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT 
 * NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN 
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
 * CONNECTION WITH THE WORK OR THE USE OR OTHER DEALINGS IN THE WORK. </p> 
 * 
 * <p> The export of software employing encryption technology may require a 
 * specific license from the United States Government. It is the 
 * responsibility of any person or organization contemplating export to obtain 
 * such a license before exporting this Work. </p>
 */

package org.osid.workflow.rules;
